var __extends = (this && this.__extends) || (function () {
    var extendStatics = Object.setPrototypeOf ||
        ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
        function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
var PathFigure = System.Windows.Media.PathFigure;
var Point = System.Windows.Point;
var PathGeometry = System.Windows.Media.PathGeometry;
var ArcSegment = System.Windows.Media.ArcSegment;
var BezierSegment = System.Windows.Media.BezierSegment;
var FillRule = System.Windows.Media.FillRule;
var LineSegment = System.Windows.Media.LineSegment;
var QuadraticBezierSegment = System.Windows.Media.QuadraticBezierSegment;
var SweepDirection = System.Windows.Media.SweepDirection;
var EventArgs = Events.EventArgs;
var Rectangle = System.Windows.Shapes.Rectangle;
var Popup = System.Windows.Controls.Primitives.Popup;
var ContentControl = System.Windows.Controls.ContentControl;
var Canvas = System.Windows.Controls.Canvas;
var Rect = System.Windows.Rect;
var Size = System.Windows.Size;
var FrameworkElement = System.Windows.FrameworkElement;
var Button = System.Windows.Controls.Button;
var Border = System.Windows.Controls.Border;
var Brush = System.Windows.Media.Brush;
var Double = System.Double;
var DependencyObject = System.Windows.DependencyObject;
var DependencyProperty = System.Windows.DependencyProperty;
var VerticalAlignment = System.Windows.VerticalAlignment;
var RoutedEventArgs = System.Windows.RoutedEventArgs;
var Cursors = System.Windows.Input.Cursors;
var MessageBoxResult = System.Windows.MessageBoxResult;
var TextBlock = System.Windows.Controls.TextBlock;
var Colors = System.Windows.Media.Colors;
var TextWrapping = System.Windows.TextWrapping;
var Delegate = Events.Delegate;
var SolidColorBrush = System.Windows.Media.SolidColorBrush;
var Guid = System.Guid;
var UserControl = System.Windows.Controls.UserControl;
var ObservableCollection = System.Collections.ObjectModel.ObservableCollection;
var KeyEventArgs = System.Windows.Input.KeyEventArgs;
var KeyInput = System.Windows.Input.Key;
var Keyboard = System.Windows.Input.Keyboard;
var ModifierKeys = System.Windows.Input.ModifierKeys;
var UIElement = System.Windows.UIElement;
var FrameworkElementAutomationPeer = System.Windows.Automation.Peers.FrameworkElementAutomationPeer;
var AutomationPeer = System.Windows.Automation.Peers.AutomationPeer;
var ScrollAmount = System.Windows.Automation.ScrollAmount;
var PatternInterface = System.Windows.Automation.Peers.PatternInterface;
var Storyboard = System.Windows.Media.Animation.Storyboard;
var ListBox = System.Windows.Controls.ListBox;
var Control = System.Windows.Controls.Control;
var TextBox = System.Windows.Controls.TextBox;
var EventHandler = System.Windows.EventHandler;
var TextAlignment = System.Windows.TextAlignment;
var Panel = System.Windows.Controls.Panel;
var TextChangedEventArgs = System.Windows.Controls.TextChangedEventArgs;
var BindingExpression = System.Windows.Data.BindingExpression;
var Validation = System.Windows.Controls.Validation;
var SizeChangedEventArgs = System.Windows.SizeChangedEventArgs;
var VisualStateManager = System.Windows.VisualStateManager;
var FocusManager = System.Windows.Input.FocusManager;
var Type = System.Type;
var VisualTreeHelper = System.Windows.Media.VisualTreeHelper;
var MouseEventHandler = System.Windows.Input.MouseEventHandler;
var MouseEventArgs = System.Windows.Input.MouseEventArgs;
var Action = System.Action;
var DependencyPropertyChangedEventArgs = System.Windows.DependencyPropertyChangedEventArgs;
var GeneralTransform = System.Windows.Media.GeneralTransform;
var PasswordBox = System.Windows.Controls.PasswordBox;
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Controls;
            (function (Controls) {
                var CustomHandler = /** @class */ (function (_super) {
                    __extends(CustomHandler, _super);
                    function CustomHandler() {
                        return _super !== null && _super.apply(this, arguments) || this;
                    }
                    return CustomHandler;
                }(Delegate));
                Controls.CustomHandler = CustomHandler;
                var KeypadEnterDelegate = /** @class */ (function (_super) {
                    __extends(KeypadEnterDelegate, _super);
                    function KeypadEnterDelegate() {
                        return _super !== null && _super.apply(this, arguments) || this;
                    }
                    return KeypadEnterDelegate;
                }(Delegate));
                Controls.KeypadEnterDelegate = KeypadEnterDelegate;
                var Keypad = /** @class */ (function (_super) {
                    __extends(Keypad, _super);
                    function Keypad() {
                        var allParams = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            allParams[_i] = arguments[_i];
                        }
                        var _this = _super.call(this) || this;
                        // resize members
                        _this.previousPos = new System.Windows.Point(0, 0);
                        // region Minimum
                        _this.toExponentialMin = false;
                        // region Maximum
                        _this.toExponentialMax = false;
                        _this.LastButtonPressedKey = null;
                        _this.Shown = new EventHandler();
                        _this.Closed = new EventHandler();
                        _this.OnKeypadEnter = new KeypadEnterDelegate();
                        _this._clearOnFirstAction = false;
                        _this._isClosing = false;
                        _this._keyPadEnter = false;
                        _this._stringValue = "";
                        _this._enteredFixedValue = "";
                        _this._value = 0;
                        _this._popUp = null;
                        _this._canvas = null;
                        _this._modal = null;
                        _this.previousPos = new System.Windows.Point(0, 0);
                        _this.resizeDir = null;
                        _this.virtualHeight = null;
                        _this.virtualWidth = null;
                        _this.m_root = null;
                        _this.m_drag = null;
                        _this.m_resize = null;
                        _this.m_label = null;
                        _this.m_input = null;
                        _this.m_numericKeyPad = null;
                        _this.m_keySeven = null;
                        _this.m_keyEight = null;
                        _this.m_keyNine = null;
                        _this.m_keyEscape = null;
                        _this.m_keyFour = null;
                        _this.m_keyFive = null;
                        _this.m_keySix = null;
                        _this.m_keyDelete = null;
                        _this.m_keyOne = null;
                        _this.m_keyTwo = null;
                        _this.m_keyThree = null;
                        _this.m_keyEnter = null;
                        _this.m_keyZero = null;
                        _this.m_keyDecimal = null;
                        _this.m_keySign = null;
                        // exclude microsoft surface as a mobile device
                        _this.isMobile = MobileUtility.IsMobile() && !/Windows NT.*Touch/i.test(navigator.userAgent);
                        switch (arguments.length) {
                            case 0:
                                _this.constructor_1();
                                break;
                            case 1:
                                _this.constructor_2(arguments[0]);
                                break;
                            default: throw "Invalid overload call for: constructor";
                        }
                        return _this;
                    }
                    Object.defineProperty(Keypad.prototype, "Title", {
                        // region Properties
                        // region Title
                        /// <summary>
                        /// Gets or sets the title of the keypad.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Keypad.TitleProperty);
                        },
                        // region Properties
                        // region Title
                        /// <summary>
                        /// Gets or sets the title of the keypad.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Keypad.TitleProperty, value);
                            $("#KeypadRoot #Label").text(value);
                            $("#KeypadRoot #Label").attr("title", value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "Minimum", {
                        // region Minimum
                        get: function () {
                            return this.GetValue(Keypad.MinimumProperty);
                        },
                        set: function (value) {
                            this.SetValue(Keypad.MinimumProperty, value);
                            this.MinimumUI = ViewPoint.Util.CommonUtilities.ReplaceSeparator(this.toExponentialMin ? value.toExponential().toUpperCase() : value.toString());
                            $('#KeypadRoot #MinimumUI').text(this.MinimumUI); //Fix DFCTS00367969, Warren
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "Maximum", {
                        // region Maximum
                        get: function () {
                            return this.GetValue(Keypad.MaximumProperty);
                        },
                        set: function (value) {
                            this.SetValue(Keypad.MaximumProperty, value);
                            this.MaximumUI = ViewPoint.Util.CommonUtilities.ReplaceSeparator(this.toExponentialMax ? value.toExponential().toUpperCase() : value.toString());
                            $('#KeypadRoot #MaximumUI').text(this.MaximumUI); //Fix DFCTS00367969, Warren
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "Left", {
                        // region Left
                        /// <summary>
                        /// Gets or sets the distance from the left side of the window to the left side of its container.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Keypad.LeftProperty);
                        },
                        // region Left
                        /// <summary>
                        /// Gets or sets the distance from the left side of the window to the left side of its container.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Keypad.LeftProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "Top", {
                        // region Top
                        /// <summary>
                        /// Gets or sets the distance from the top side of the window to the top side of its container.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Keypad.TopProperty);
                        },
                        // region Top
                        /// <summary>
                        /// Gets or sets the distance from the top side of the window to the top side of its container.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Keypad.TopProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "ModalBackground", {
                        // region ModalBackground
                        /// <summary>
                        /// Gets or sets the brushed used on the background when showing a modal window.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Keypad.ModalBackgroundProperty);
                        },
                        // region ModalBackground
                        /// <summary>
                        /// Gets or sets the brushed used on the background when showing a modal window.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Keypad.ModalBackgroundProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "Display", {
                        get: function () {
                            return this._display;
                        },
                        set: function (value) {
                            this._display = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "InitialKeyStroke", {
                        /// <summary>
                        /// If set prior to show, this value will be the inital value shown in the key input
                        /// </summary>
                        get: function () {
                            return this._initialKeyStroke;
                        },
                        /// <summary>
                        /// If set prior to show, this value will be the inital value shown in the key input
                        /// </summary>
                        set: function (value) {
                            this._initialKeyStroke = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "InitialValue", {
                        /// <summary>
                        /// The intial display value - can only be set once each time the keypad is open - current culture
                        /// </summary>
                        get: function () {
                            return this._initialValue;
                        },
                        /// <summary>
                        /// The intial display value - can only be set once each time the keypad is open - current culture
                        /// </summary>
                        set: function (value) {
                            this._initialValue = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "IsDecimalFixed", {
                        /// <summary>
                        /// If true, then the displayed value has a fixed decimal point.  Meaning the user
                        /// will not be able to enter their own decimal position.  The position is determined 
                        /// by DigitsAfterDecimal
                        /// </summary>
                        get: function () {
                            return this._isDecimalFixed;
                        },
                        /// <summary>
                        /// If true, then the displayed value has a fixed decimal point.  Meaning the user
                        /// will not be able to enter their own decimal position.  The position is determined 
                        /// by DigitsAfterDecimal
                        /// </summary>
                        set: function (value) {
                            this._isDecimalFixed = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "DigitsAfterDecimal", {
                        /// <summary>
                        /// Only matters if IsDecimalFixed is true.  Displays a fixed number of digits after the 
                        /// decimal
                        /// </summary>
                        get: function () {
                            return this._digitsAfterDecimal;
                        },
                        /// <summary>
                        /// Only matters if IsDecimalFixed is true.  Displays a fixed number of digits after the 
                        /// decimal
                        /// </summary>
                        set: function (value) {
                            this._digitsAfterDecimal = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "InputLength", {
                        /// <summary>
                        /// Input length of the entry
                        /// </summary>
                        get: function () {
                            return this._inputLength;
                        },
                        /// <summary>
                        /// Input length of the entry
                        /// </summary>
                        set: function (value) {
                            this._inputLength = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "TriggerObject", {
                        /// <summary>
                        /// Object that created this control.  Used to position the Keypad control.
                        /// </summary>
                        get: function () {
                            return this._triggerObject;
                        },
                        /// <summary>
                        /// Object that created this control.  Used to position the Keypad control.
                        /// </summary>
                        set: function (value) {
                            this._triggerObject = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "ClipPoint", {
                        /// <summary>
                        /// Clip point.  Set to determine where to start the modal canvas for this popup.
                        /// </summary>
                        get: function () {
                            return this._clipPoint;
                        },
                        /// <summary>
                        /// Clip point.  Set to determine where to start the modal canvas for this popup.
                        /// </summary>
                        set: function (value) {
                            this._clipPoint = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "IsScratchPad", {
                        /// <summary>
                        /// Treat the keypad as a scratch pad
                        /// </summary>
                        get: function () {
                            return this._isScratchPad;
                        },
                        /// <summary>
                        /// Treat the keypad as a scratch pad
                        /// </summary>
                        set: function (value) {
                            this._isScratchPad = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Keypad.prototype, "StringValue", {
                        // Do not call this property directly as it is bound to the Text property of the TextBox
                        get: function () {
                            return this._stringValue;
                        },
                        // Do not call this property directly as it is bound to the Text property of the TextBox
                        set: function (value) {
                            KeypadValidation.ValidateString(value, this);
                            this._stringValue = value;
                            // removed realtime validation
                        },
                        enumerable: true,
                        configurable: true
                    });
                    // region VisualStates Groups
                    Keypad.prototype.ChangeVisualStateOpen = function (useTransitions) {
                        if (this._isClosing) {
                            ViewPoint.Client.Toolkit.Utilities.VisualStateHelper.GoToState(this, "Closed", useTransitions);
                            var dlg = $("#KeypadRoot");
                            dlg.modal("hide");
                            this.OnCloseComplete(this, null);
                        }
                        else {
                            ViewPoint.Client.Toolkit.Utilities.VisualStateHelper.GoToState(this, "Open", useTransitions);
                        }
                    };
                    // region property changes
                    Keypad.prototype.OnLeftChanged = function () {
                        this.SetValue(Canvas.LeftProperty, this.Left);
                    };
                    Keypad.prototype.OnTopChanged = function () {
                        this.SetValue(Canvas.TopProperty, this.Top);
                    };
                    // region resizing
                    Keypad.prototype.ResizeMouseDown = function (pos) {
                        this.m_resize.CaptureMouse();
                        this.previousPos = pos;
                        this.resizeDir = this.ResizeDir(pos);
                        this.Width = this.virtualWidth = this.ActualWidth;
                        this.Height = this.virtualHeight = this.ActualHeight;
                    };
                    Keypad.prototype.ResizeMouseMove = function (pos) {
                        if (this.resizeDir != new System.Windows.Point(0, 0)) {
                            var resize = new System.Windows.Point(this.resizeDir.X * (pos.X - this.previousPos.X), this.resizeDir.Y * (pos.Y - this.previousPos.Y));
                            this.virtualWidth += resize.X;
                            this.virtualHeight += resize.Y;
                            var actualResize = new System.Windows.Point(this.BoundWidth(this.virtualWidth) - this.Width, this.BoundHeight(this.virtualHeight) - this.Height);
                            this.Width += actualResize.X;
                            this.Height += actualResize.Y;
                            if (this.resizeDir.X < 0)
                                this.Left -= actualResize.X;
                            if (this.resizeDir.Y < 0)
                                this.Top -= actualResize.Y;
                            this.previousPos = new System.Windows.Point(pos.X + (this.resizeDir.X < 0 ? actualResize.X : 0), pos.Y + (this.resizeDir.Y < 0 ? actualResize.Y : 0));
                        }
                        else {
                            var dir = this.ResizeDir(pos);
                            if (dir.X != 0 && dir.Y != 0)
                                this.m_resize.Cursor = Cursors.Hand;
                            else if (dir.X != 0)
                                this.m_resize.Cursor = Cursors.SizeWE;
                            else if (dir.Y != 0)
                                this.m_resize.Cursor = Cursors.SizeNS;
                            else
                                this.m_resize.Cursor = Cursors.Arrow;
                        }
                    };
                    Keypad.prototype.ResizeMouseUp = function () {
                        this.m_resize.ReleaseMouseCapture();
                        this.resizeDir = new System.Windows.Point(0, 0);
                    };
                    // returns the direction of resize corresponding to a mouse position inside the window
                    // the return type is a Point used as a vector
                    Keypad.prototype.ResizeDir = function (pos) {
                        var dir = new System.Windows.Point(0, 0);
                        if (pos.X < this.m_resize.BorderThickness.Left)
                            dir.X = -1;
                        else if (pos.X >= this.m_resize.ActualWidth - this.m_resize.BorderThickness.Right)
                            dir.X = 1;
                        if (pos.Y < this.m_resize.BorderThickness.Top)
                            dir.Y = -1;
                        else if (pos.Y >= this.m_resize.ActualHeight - this.m_resize.BorderThickness.Bottom)
                            dir.Y = 1;
                        return dir;
                    };
                    // returns the width bounded to the minimum and maximum width of the window
                    Keypad.prototype.BoundWidth = function (width) {
                        return Math.max(width, this.m_root.MinWidth);
                    };
                    // returns the height bounded to the minimum and maximum width of the height
                    Keypad.prototype.BoundHeight = function (height) {
                        return Math.max(height, this.m_root.MinHeight);
                    };
                    Keypad.prototype.OnApplyTemplate = function () {
                        _super.prototype.OnApplyTemplate.call(this);
                        // Get the elements
                        this.m_root = this.GetTemplateChild(Keypad.RootElementName);
                        this.m_root.DataContext = this;
                        this.m_drag = this.GetTemplateChild(Keypad.DragElementName);
                        this.m_resize = this.GetTemplateChild(Keypad.ResizeElementName);
                        this.m_label = this.GetTemplateChild(Keypad.LabelElementName);
                        this.m_input = this.GetTemplateChild(Keypad.InputElementName);
                        this.m_numericKeyPad = this.GetTemplateChild(Keypad.NumericKeyPad);
                        this.m_keySeven = this.GetTemplateChild(Keypad.KeySevenElementName);
                        this.OnClick(this.m_keySeven, function () {
                            this.HandleKey(KeyInput.D7);
                        });
                        this.m_keyEight = this.GetTemplateChild(Keypad.KeyEightElementName);
                        this.OnClick(this.m_keyEight, function () {
                            this.HandleKey(KeyInput.D8);
                        });
                        this.m_keyNine = this.GetTemplateChild(Keypad.KeyNineElementName);
                        this.OnClick(this.m_keyNine, function () {
                            this.HandleKey(KeyInput.D9);
                        });
                        this.m_keyEscape = this.GetTemplateChild(Keypad.KeyEscapeElementName);
                        this.OnClick(this.m_keyEscape, function () {
                            this.HandleKey(KeyInput.Escape);
                        });
                        this.m_keyFour = this.GetTemplateChild(Keypad.KeyFourElementName);
                        this.OnClick(this.m_keyFour, function () {
                            this.HandleKey(KeyInput.D4);
                        });
                        this.m_keyFive = this.GetTemplateChild(Keypad.KeyFiveElementName);
                        this.OnClick(this.m_keyFive, function () {
                            this.HandleKey(KeyInput.D5);
                        });
                        this.m_keySix = this.GetTemplateChild(Keypad.KeySixElementName);
                        this.OnClick(this.m_keySix, function () {
                            this.HandleKey(KeyInput.D6);
                        });
                        this.m_keyDelete = this.GetTemplateChild(Keypad.KeyDeleteElementName);
                        this.OnClick(this.m_keyDelete, function () {
                            this.HandleKey(KeyInput.Delete);
                        });
                        this.m_keyOne = this.GetTemplateChild(Keypad.KeyOneElementName);
                        this.OnClick(this.m_keyOne, function () {
                            this.HandleKey(KeyInput.D1);
                        });
                        this.m_keyTwo = this.GetTemplateChild(Keypad.KeyTwoElementName);
                        this.OnClick(this.m_keyTwo, function () {
                            this.HandleKey(KeyInput.D2);
                        });
                        this.m_keyThree = this.GetTemplateChild(Keypad.KeyThreeElementName);
                        this.OnClick(this.m_keyThree, function () {
                            this.HandleKey(KeyInput.D3);
                        });
                        this.m_keyEnter = this.GetTemplateChild(Keypad.KeyEnterElementName);
                        this.OnClick(this.m_keyEnter, function () {
                            this.HandleKey(KeyInput.Enter);
                        });
                        this.m_keyZero = this.GetTemplateChild(Keypad.KeyZeroElementName);
                        this.OnClick(this.m_keyZero, function () {
                            this.HandleKey(KeyInput.D0);
                        });
                        this.m_keyDecimal = this.GetTemplateChild(Keypad.KeyDecimalElementName);
                        this.m_keySign = this.GetTemplateChild(Keypad.KeySignElementName);
                        this.OnClick(this.m_keySign, function () {
                            this.HandleKey(KeyInput.Add);
                        });
                        // If decimal fixed, then don't enable the decimal key
                        if (this.IsDecimalFixed) {
                            // Disable the decimal
                            this.m_keyDecimal.IsEnabled = false;
                        }
                        else {
                            this.OnClick(this.m_keyDecimal, function () {
                                this.HandleKey(KeyInput.Decimal);
                            });
                        }
                        this.InitializeDragPart();
                        this.InitializeResizePart();
                        this.ChangeVisualStateOpen(true);
                        if (this.IsScratchPad) {
                            // hide the keypad
                            this.m_numericKeyPad.Visibility = 1 /* Collapsed */;
                            this.m_root.MinHeight = 70;
                        }
                    };
                    Keypad.prototype.Initialize = function () {
                        if (this._canvas == null) {
                            this._modal = new System.Windows.Shapes.Rectangle();
                            this._canvas = new System.Windows.Controls.Canvas();
                            this._canvas.SizeChanged.subscribe(this.CanvasSizeChanged, this);
                            this._canvas.SetValue(Canvas.ZIndexProperty, Keypad.ZIndex);
                            this._popUp = (function () {
                                var _tmp = new System.Windows.Controls.Primitives.Popup;
                                _tmp.Child = this._canvas;
                                _tmp.IsOpen = true;
                                return _tmp;
                            })();
                            this._popUp.Closed.subscribe(this.PopUp_Closed, this);
                            this.AttachControl();
                        }
                        this.IsHitTestVisible = true;
                        this.Loaded.subscribe(this.Keypad_Loaded, this);
                        this.MouseLeftButtonDown.subscribe(function (s, e) {
                            this.Focus();
                        }, this);
                        // boolean to indicate that the displayed values should be cleared first 
                        // when the users first takes action on the keypad
                        this._clearOnFirstAction = true;
                    };
                    /// <summary>
                    /// The popup was closed outside of this class.  Use this to clean up.
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    Keypad.prototype.PopUp_Closed = function (sender, e) {
                        this.OnCloseComplete(sender, e);
                        if (this.Display != null) {
                            this.Display.Children.Remove(this._popUp);
                        }
                    };
                    Keypad.prototype.InitializeDragPart = function () {
                        /*AIS_TODO var dragHelper : MouseHelper = new ViewPoint.Client.Toolkit.Utilities.MouseHelper(this.m_drag);
                        dragHelper.RelativeTo = this.Display;
                        dragHelper.MouseDragMove.subscribe(function (s,e) {
                           var size : any = new System.Windows.Size(this._canvas.ActualWidth, this._canvas.ActualHeight);
                           var currentPoint : any = e.GetPosition(this._canvas);
                           var previousPoint : any = e.PreviousPosition;
                           // C1TransformToVisual throws when canvas is in a popup
                           if (!(lang.isType<Popup>(this._canvas.Parent))) {
                              previousPoint = Application.Current.RootVisual.TransformToVisual(this._canvas).Transform(previousPoint);
                           }
                           this.Left += Math.min(size.Width, Math.max(currentPoint.X, 0)) - Math.min(size.Width, Math.max(previousPoint.X, 0));
                           this.Top += Math.min(size.Height, Math.max(currentPoint.Y, 0)) - Math.min(size.Height, Math.max(previousPoint.Y, 0));
                           this.InvalidateMeasure();
                        }, this);*/
                    };
                    Keypad.prototype.InitializeResizePart = function () {
                        this.m_resize.MouseLeftButtonDown.subscribe(function (s, e) {
                            return this.ResizeMouseDown(e.GetPosition(this.m_resize));
                        }, this);
                        this.m_resize.MouseMove.subscribe(function (s, e) {
                            return this.ResizeMouseMove(e.GetPosition(this.m_resize));
                        }, this);
                        // hook from mouse enter so that the correct cursor is shown when the mouse just entered but hasn't moved yet
                        this.m_resize.MouseEnter.subscribe(function (s, e) {
                            return this.ResizeMouseMove(e.GetPosition(this.m_resize));
                        }, this);
                        this.m_resize.MouseLeftButtonUp.subscribe(function (s, e) {
                            return this.ResizeMouseUp();
                        }, this);
                    };
                    Keypad.prototype.CanvasSizeChanged = function (sender, e) {
                        if (this.Left + this.ActualWidth + this.ClipPoint.X > this._canvas.ActualWidth) {
                            this.Left = this._canvas.ActualWidth - this.ActualWidth - this.ClipPoint.X;
                        }
                        if (this.Top + this.ActualHeight + this.ClipPoint.Y > this._canvas.ActualHeight) {
                            this.Top = this._canvas.ActualHeight - this.ActualHeight - this.ClipPoint.Y;
                        }
                        if (this.Left < this.ClipPoint.X) {
                            this.Left = this.ClipPoint.X;
                        }
                        if (this.Top < this.ClipPoint.Y) {
                            this.Top = this.ClipPoint.Y;
                        }
                        this._modal.Width = this._canvas.ActualWidth;
                        this._modal.Height = this._canvas.ActualHeight;
                        this._canvas.Clip = (function () {
                            var _tmp = new System.Windows.Media.RectangleGeometry;
                            _tmp.Rect = new System.Windows.Rect(this.ClipPoint.X, this.ClipPoint.Y, this._canvas.ActualWidth - this.ClipPoint.X, this._canvas.ActualHeight - this.ClipPoint.Y);
                            return _tmp;
                        })();
                    };
                    Keypad.prototype.AttachControl = function () {
                        if (this.Display != null) {
                            this.Display.Children.Add(this._popUp);
                            this.Display.SizeChanged.subscribe(this.Content_Resized, this);
                        }
                        else {
                            Application.Current.Host.Content.Resized.subscribe(this.Content_Resized, this);
                        }
                        this.Content_Resized(null, null);
                    };
                    /// <summary>
                    /// Resizes the default canvas.  Note: Do not use parameters as method calls
                    /// may pass null.
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    Keypad.prototype.Content_Resized = function (sender, e) {
                        if (this.Display != null) {
                            this._canvas.Width = this.Display.ActualWidth;
                            this._canvas.Height = this.Display.ActualHeight;
                        }
                        else {
                            this._canvas.Width = Application.Current.Host.Content.ActualWidth;
                            this._canvas.Height = Application.Current.Host.Content.ActualHeight;
                        }
                    };
                    Keypad.prototype.Keypad_Loaded = function (sender, e) {
                        this.ApplyTemplate();
                        this.Focus();
                    };
                    /// <summary>
                    /// Updates the display according to the Digits after decimal.
                    /// </summary>
                    /// <param name="value">Culture variant input value</param>
                    Keypad.prototype.HandleFixedDisplay = function (value) {
                        var dp = (this.DigitsAfterDecimal > 0) ? CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator : "";
                        var negative = "-";
                        negative = (this.StringValue.indexOf(negative) >= 0) ? negative : "";
                        if (this.InputLength != 0 && this._enteredFixedValue.length + dp.length + negative.length + value.length > this.InputLength) {
                            return;
                        }
                        this._enteredFixedValue += value;
                        if (this._enteredFixedValue.length <= this.DigitsAfterDecimal) {
                            var zero = "0";
                            this.StringValue = negative + zero + dp + System.String.createString(zero[0], this.DigitsAfterDecimal - this._enteredFixedValue.length) + this._enteredFixedValue;
                        }
                        else {
                            this.StringValue = negative + this._enteredFixedValue.Insert(this._enteredFixedValue.length - this.DigitsAfterDecimal, dp);
                        }
                    };
                    Keypad.prototype.GoToState = function (sender, KeyNameIndex, state) {
                        if (!sender) {
                            return;
                        }
                        console.assert(KeyNameIndex < Keypad.KeysName.length, "KeyNameIndex out of range");
                        if (KeyNameIndex < Keypad.KeysName.length) {
                            var Button = $(sender).find(Keypad.KeysName[KeyNameIndex]);
                            console.assert(Button !== undefined, (Keypad.KeysName[KeyNameIndex] + " is null or undefined"));
                            if (Button) {
                                if (state == "Pressed") {
                                    Button.addClass("KeyPadPressedButtonBackground");
                                    Button.removeClass("KeyPadNormalButtonBackground");
                                }
                                else {
                                    Button.addClass("KeyPadNormalButtonBackground");
                                    Button.removeClass("KeyPadPressedButtonBackground");
                                }
                            }
                        }
                    };
                    /// <summary>
                    /// Handles the key after the user clicks on a key or uses the keyboard.
                    /// </summary>
                    /// <param name="key">keycode from keypress event</param>
                    Keypad.prototype.HandleKey = function (key) {
                        // Note: key is keycode parameter for keypress event, value is different from `System.Windows.Input.Key` enums. Patrick
                        var zero = "0";
                        if (this._clearOnFirstAction) {
                            this._clearOnFirstAction = false;
                            this.StringValue = zero;
                        }
                        // Only D# keys should be allowed at this point
                        if (KeyInput.D0 <= key && key <= KeyInput.D9) {
                            var value = (KeyInput.D0 <= key && key <= KeyInput.D9) ? key - KeyInput.D0 : key - KeyInput.NumPad0;
                            if (this.IsDecimalFixed) {
                                this.HandleFixedDisplay(value.toString());
                            }
                            else {
                                // Display only one 0 if its the first number and user keeps pushing 0
                                if (this.StringValue.length == 1 && System.String.Compare(this.StringValue, "0", StringComparison.CurrentCulture) == 0) {
                                    this.StringValue = value.toString();
                                }
                                else {
                                    if (this.InputLength != 0 && this.StringValue.length + 1 > this.InputLength) {
                                        return;
                                    }
                                    this.StringValue += value.toString();
                                }
                            }
                        }
                        else if (key == 46 && !this.IsDecimalFixed) {
                            if (this.StringValue.indexOf(".", StringComparison.CurrentCulture) == -1) {
                                if (this.InputLength != 0 && this.StringValue.length + 1 > this.InputLength) {
                                    return;
                                }
                                this.StringValue += ".";
                            }
                        }
                        else if (key == 45) {
                            var negative = "-";
                            var totalLength = 0;
                            // Note: 'binary', 'octal' and 'hexadecimal' numeric input don't support entering negative values
                            switch (this.NumericFormat) {
                                case 'binary':
                                case 'octal':
                                case 'hexadecimal':
                                    return;
                                // Scientific notation support for NumericInput of 'floatingPoint' format on SE, e.g.: `-3e-2 = -0.03`
                                // Allow input multiple "-" sign
                                case 'floatingPoint':
                                    if (this.StringValue.length == 1 && System.String.Compare(this.StringValue, "0", StringComparison.CurrentCulture) == 0) {
                                        this.StringValue = negative;
                                    }
                                    else {
                                        if (this.InputLength != 0 && totalLength + 1 > this.InputLength) {
                                            return;
                                        }
                                        this.StringValue += negative;
                                    }
                                    return;
                            }
                            if (this.IsDecimalFixed) {
                                var dp = (this.DigitsAfterDecimal > 0) ? CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator : "";
                                totalLength = this._enteredFixedValue.length + dp.length;
                            }
                            else {
                                totalLength = this.StringValue.length;
                            }
                            if (this.StringValue.length > 1 || (this.StringValue.length == 1 && System.String.Compare(this.StringValue, "0", StringComparison.CurrentCulture) != 0)) {
                                if (System.String.Compare(this.StringValue.substr(0, 1), negative, StringComparison.CurrentCulture) == 0) {
                                    this.StringValue = this.StringValue.substr(1, this.StringValue.length - 1);
                                }
                                else {
                                    if (this.InputLength != 0 && totalLength + 1 > this.InputLength) {
                                        return;
                                    }
                                    this.StringValue = this.StringValue.Insert(0, negative);
                                }
                            }
                        }
                        else if (key == 43 /* '+' key on num pad */ || key == 61 /* '=/+' key beside backspace */) {
                            // Split from the above condition, do not change number sign if `+` key pressed. Patrick
                        }
                        else if (this.IsNumericInputControl && this.NumericFormat == 'hexadecimal') {
                            // [A-F] and [a-f] characters for hexadecimal input in SE
                            if (65 <= key && key <= 70 || 97 <= key && key <= 102) {
                                if (this.StringValue.length == 1 && System.String.Compare(this.StringValue, "0", StringComparison.CurrentCulture) == 0) {
                                    this.StringValue = String.fromCharCode(key);
                                }
                                else {
                                    if (this.InputLength != 0 && this.StringValue.length + 1 > this.InputLength) {
                                        return;
                                    }
                                    this.StringValue += String.fromCharCode(key);
                                }
                            }
                        }
                        else if (this.IsNumericInputControl && this.NumericFormat == 'floatingPoint') {
                            // Scientific notation support for NumericInput of 'floatingPoint' format on SE, e.g.: `-3e-2 = -0.03`
                            // Only one 'e' or 'E' character allowed
                            if (key == 101 || key == 69) {
                                if (/e/i.test(this.StringValue)) {
                                    // Make sure one "e/E" at most
                                    return;
                                }
                                if (this.StringValue.length == 1 && System.String.Compare(this.StringValue, "0", StringComparison.CurrentCulture) == 0) {
                                    this.StringValue = String.fromCharCode(key);
                                }
                                else {
                                    if (this.InputLength != 0 && this.StringValue.length + 1 > this.InputLength) {
                                        return;
                                    }
                                    this.StringValue += String.fromCharCode(key);
                                }
                            }
                        }
                    };
                    Keypad.prototype.OnClick = function (key, a) {
                        var handler = function (s, e) {
                            a();
                        };
                        key.Click.subscribe(handler, this);
                    };
                    Keypad.prototype.OnLayout = function (a) {
                        var handler = function (s, e) {
                            a.raise();
                            this.LayoutUpdated.unsubscribe(handler);
                        };
                        this.LayoutUpdated.subscribe(handler, this);
                        /*AIS_TODO this.InvalidateMeasure();*/
                    };
                    /// <summary>
                    /// The control is no longer valid once it closes.
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    Keypad.prototype.OnCloseComplete = function (sender, e) {
                        if (this.OnKeypadEnter != null) {
                            try {
                                if (this._keyPadEnter) {
                                    if (this.IsNumericInputControl) {
                                        this._value = this.StringValue;
                                    }
                                    else {
                                        this._value = Double.Parse(this.StringValue, CultureInfo.CurrentCulture);
                                    }
                                    this.OnKeypadEnter.raise(this._value);
                                }
                            }
                            catch (ex) {
                                Controls.DialogBox.Show(ex.message, Controls.MessageType.Error, Controls.DialogBoxButtons.Ok);
                            }
                        }
                        if (this.Display != null) {
                            this.Display.SizeChanged.unsubscribe(this.Content_Resized);
                        }
                        else {
                            Application.Current.Host.Content.Resized.unsubscribe(this.Content_Resized);
                        }
                        this._canvas.Children.Remove(this._modal);
                        this._canvas.Children.Remove(this);
                        this._canvas.SizeChanged.unsubscribe(this.CanvasSizeChanged);
                        this._popUp.Closed.unsubscribe(this.PopUp_Closed);
                        this._popUp.IsOpen = false;
                        this._popUp.Child = null;
                        if (this.Closed != null)
                            this.Closed.raise(this, null);
                        // Keypad and scratchpad fix, Patrick
                        // Trick: hide mobile virtual keyboard after scratchpad closed
                        if (this.isMobile) {
                            document.activeElement.blur();
                            var inputs = document.querySelectorAll('input');
                            for (var i = 0; i < inputs.length; i++) {
                                inputs[i].blur();
                            }
                        }
                    };
                    Keypad.prototype.Show = function () {
                        var allParams = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            allParams[_i] = arguments[_i];
                        }
                        switch (arguments.length) {
                            case 0: return this.Show_1();
                            case 1: return this.Show_2(arguments[0]);
                            default: throw "Invalid overload call for: Show";
                        }
                    };
                    Keypad.prototype.Show_1 = function () {
                        var _this = this;
                        this.Focus();
                        // Initialize entered value
                        this._enteredFixedValue = "";
                        this._canvas.Children.Add(this._modal);
                        this._canvas.Children.Add(this);
                        // Property set after added to UI Tree
                        this._modal.Fill = this.ModalBackground;
                        var dlg = $("#KeypadRoot");
                        if (/Windows NT.*Touch/i.test(navigator.userAgent)) {
                            dlg.addClass('ms-surface');
                        }
                        else {
                            dlg.removeClass('ms-surface');
                        }
                        if (this.IsDecimalFixed) {
                            dlg.find('#KeyDecimal').attr('disabled', true);
                            dlg.find('#KeyDecimal').removeClass("KeyPadNormalButtonBackground");
                            dlg.find('#KeyDecimal').addClass("KeyPadDisabledButtonBackground");
                        }
                        else {
                            dlg.find('#KeyDecimal').removeAttr("disabled");
                            dlg.find('#KeyDecimal').removeClass("KeyPadDisabledButtonBackground");
                            dlg.find('#KeyDecimal').addClass("KeyPadNormalButtonBackground");
                        }
                        // Minimum and maximum will be `NaN` for NumericInput, so hide it
                        if (this.IsNumericInputControl) {
                            dlg.find('#Minimum_Maximum').hide();
                        }
                        else {
                            dlg.find('#Minimum_Maximum').show();
                        }
                        // If no title, hide `<div id="Drag">`
                        if (this.Title) {
                            dlg
                                .find("#Drag")
                                .show()
                                .find("#Label")
                                .css("visibility", "visible");
                        }
                        else {
                            dlg
                                .find("#Drag")
                                .hide()
                                .find("#Label")
                                .css("visibility", "hidden");
                        }
                        this.SetInitialValue();
                        // limit maximum input length
                        dlg.find('#Input').attr("maxlength", this.InputLength);
                        dlg.one("shown.bs.modal", function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            _this.OnBootstrapModalShown.apply(_this, args);
                        });
                        dlg.one("hidden.bs.modal", function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            _this.onBootstrapModalHidden.apply(_this, args);
                        });
                        dlg.modal({
                            backdrop: "static",
                            keyboard: false,
                            show: true
                        });
                        dlg.css("overflow", "visible");
                        // Draggable area calculation
                        var area = ViewPoint.Util.CommonUtilities.CalculateDraggableArea(dlg);
                        dlg.find("#keyPadContent").draggable({
                            containment: $("#DisplayArea")
                        });
                        if (this.InitialKeyStroke != KeyInput.None && this.InitialKeyStroke != KeyInput.Enter) {
                            this.HandleKey(this.InitialKeyStroke);
                        }
                        // Set border style
                        this.Shown.raise(this, null);
                    };
                    Keypad.prototype.Show_2 = function (key) {
                        this.InitialKeyStroke = key;
                        this.Show();
                    };
                    Keypad.prototype.OnBootstrapModalShown = function (event) {
                        var _this = this;
                        var dlg = $("#KeypadRoot");
                        $(document).on("keydown", function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            _this.onKeydownEventHandler.apply(_this, args);
                        });
                        dlg.find("#Input").on("input", function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            _this.onInputEventHandler.apply(_this, args);
                        });
                        if (!dlg.find("#keyPadContent").hasClass("ui-resizable") && !this.isMobile) {
                            dlg.find("#keyPadContent").resizable({
                                minHeight: dlg.find(".modal-content").height(),
                                minWidth: dlg.find(".modal-content").width(),
                                handles: "all"
                            }).on("resize", function (event, ui) {
                                Control.KPresize = true;
                            });
                        }
                        var buttons = dlg.find(".modal-footer button");
                        buttons.css("background-color", "transparent");
                        setTimeout(function () { return dlg.find("#Input").focus(); }, 200);
                    };
                    Keypad.prototype.onBootstrapModalHidden = function (event) {
                        var dlg = $("#KeypadRoot");
                        var input = dlg.find('#Input');
                        input.removeAttr("title");
                        KeypadValidation.destroyValidationError();
                        $(document).off("keydown");
                        dlg.find("#Input").off("input");
                    };
                    Keypad.prototype.onKeydownEventHandler = function (event) {
                        switch (event.which) {
                            // after press esc key, close modal dialog
                            case KeyInput.Escape:
                                this._isClosing = true;
                                this.ChangeVisualStateOpen(true);
                                break;
                            // after press enter key, validate and close dialog
                            case KeyInput.Enter:
                                var isValid = false;
                                if (this.IsNumericInputControl) {
                                    isValid = KeypadValidation.ValidateNumericInput(this.StringValue, this);
                                }
                                else {
                                    isValid = KeypadValidation.ValidateString(this.StringValue, this);
                                }
                                if (isValid) {
                                    this._isClosing = true;
                                    this._keyPadEnter = true;
                                    this.ChangeVisualStateOpen(true);
                                    event.preventDefault();
                                }
                                break;
                            // destroy validation error tooltip
                            default:
                                KeypadValidation.destroyValidationError();
                        }
                    };
                    Keypad.prototype.onInputEventHandler = function (event) {
                        var eventTarget = event.target;
                        if (this._isDecimalFixed) {
                            var sign = '';
                            if (eventTarget.value && eventTarget.value.indexOf('-') > -1) {
                                var negativeCount = 0;
                                for (var i = 0; i < eventTarget.value.length; i++) {
                                    if (eventTarget.value[i] == '-') {
                                        negativeCount++;
                                    }
                                }
                                sign = negativeCount == 1 ? '-' : '';
                                eventTarget.value = eventTarget.value.replace('-', '');
                            }
                            eventTarget.value = ("0" + eventTarget.value).match(/[0-9]/g).join("");
                            eventTarget.value = eventTarget.value.replace(/\.|^[0|\.]+/g, '');
                            if (eventTarget.value == '') {
                                eventTarget.value = '0';
                            }
                            eventTarget.value = sign + (parseFloat(eventTarget.value) / Math.pow(10, this.DigitsAfterDecimal)).toFixed(this.DigitsAfterDecimal).toString();
                            eventTarget.value = eventTarget.value.replace(CultureInfo.InvariantCulture.NumberFormat.NumberDecimalSeparator, CultureInfo.CurrentCulture.NumberFormat.NumberDecimalSeparator);
                        }
                        this.StringValue = eventTarget.value;
                    };
                    // bind to `ng-click` directive, when click 'ok' button to submit numeric input
                    Keypad.prototype.Submit_Change = function (sender, e) {
                        var str = $("#KeypadRoot #Input").val();
                        // use a different validation for NumericInput control
                        var result = false;
                        if (this.IsNumericInputControl) {
                            result = KeypadValidation.ValidateNumericInput(str, this);
                        }
                        else {
                            result = KeypadValidation.ValidateString(str, this);
                        }
                        if (result) {
                            this.StringValue = str;
                            this._isClosing = true;
                            this._keyPadEnter = true;
                            this.ChangeVisualStateOpen(true);
                        }
                    };
                    // bind to `ng-click` directive, when click 'cancel' button to cancel numeric input
                    Keypad.prototype.Cancel_Change = function (sender, e) {
                        this._isClosing = true;
                        this.ChangeVisualStateOpen(true);
                    };
                    /// <summary>
                    /// Called once the keypad is shown
                    /// </summary>
                    Keypad.prototype.SetInitialValue = function () {
                        var Label = $("#KeypadRoot #Label");
                        if (this.InitialKeyStroke == KeyInput.None || this.InitialKeyStroke == KeyInput.Enter) {
                            // Note: `InitialValue` may equal to empty string "".
                            // If it's empty string, we set it to "0" will prevent showing a format error tooltip when initialization.
                            // @see ViewPoint.Client.Controls.NumericInput#NumericPadInitialValue
                            this.StringValue = this.InitialValue == "" ? "0" : this.InitialValue;
                            $("#KeypadRoot #Input").val(this.StringValue);
                        }
                        Label.css("visibility", "visible");
                    };
                    Keypad.OnLeftPropertyChanged = function (d, e) {
                        var sender = lang.asType(d);
                        // Call the hook method if is required
                        sender.OnLeftChanged();
                    };
                    Keypad.OnTopPropertyChanged = function (d, e) {
                        var sender = lang.asType(d);
                        // Call the hook method if is required
                        sender.OnTopChanged();
                    };
                    Keypad.prototype.constructor_1 = function () {
                        this.DefaultStyleKey = lang.typeOf();
                        this.Initialize();
                    };
                    /// <summary>
                    /// 
                    /// </summary>
                    /// <param name="p">Panel to attach popup to.  If null, popup attaches to main content</param>
                    Keypad.prototype.constructor_2 = function (p) {
                        this.DefaultStyleKey = lang.typeOf();
                        this.Display = p;
                        this.Initialize();
                    };
                    // this value must be negative so that users can open tooltips and popup over windows
                    Keypad.ZIndex = -10000;
                    Keypad.RootElementName = "Root";
                    Keypad.DragElementName = "Drag";
                    Keypad.ResizeElementName = "Resize";
                    Keypad.LabelElementName = "Label";
                    Keypad.InputElementName = "Input";
                    Keypad.NumericKeyPad = "NumericKeyPad";
                    Keypad.KeySevenElementName = "KeySeven";
                    Keypad.KeyEightElementName = "KeyEight";
                    Keypad.KeyNineElementName = "KeyNine";
                    Keypad.KeyEscapeElementName = "KeyEscape";
                    Keypad.KeyFourElementName = "KeyFour";
                    Keypad.KeyFiveElementName = "KeyFive";
                    Keypad.KeySixElementName = "KeySix";
                    Keypad.KeyDeleteElementName = "KeyDelete";
                    Keypad.KeyOneElementName = "KeyOne";
                    Keypad.KeyTwoElementName = "KeyTwo";
                    Keypad.KeyThreeElementName = "KeyThree";
                    Keypad.KeyEnterElementName = "KeyEnter";
                    Keypad.KeyZeroElementName = "KeyZero";
                    Keypad.KeyDecimalElementName = "KeyDecimal";
                    Keypad.KeySignElementName = "KeySign";
                    Keypad.KeysName = ["#KeyZero", "#KeyOne", "#KeyTwo", "#KeyThree", "#KeyFour", "#KeyFive", "#KeySix",
                        "#KeySeven", "#KeyEight", "#KeyNine", "#KeyDecimal", "#KeySign", "#KeyEscape", "#KeyDelete", "#KeyEnter"];
                    /// <summary>
                    /// Identifies the <see cref="ShowCloseButton"/> dependency property. 
                    /// </summary>
                    Keypad.TitleProperty = DependencyProperty.Register("Title", new System.Windows.PropertyMetadata("Keypad"));
                    Keypad.MinimumProperty = DependencyProperty.Register("Minimum", null);
                    Keypad.MaximumProperty = DependencyProperty.Register("Maximum", null);
                    /// <summary>
                    /// Identifies the <see cref="Left"/> dependency property. 
                    /// </summary>
                    Keypad.LeftProperty = DependencyProperty.Register("Left", new System.Windows.PropertyMetadata(Keypad.OnLeftPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="Top"/> dependency property. 
                    /// </summary>
                    Keypad.TopProperty = DependencyProperty.Register("Top", new System.Windows.PropertyMetadata(Keypad.OnTopPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="ModalBackground"/> dependency property. 
                    /// </summary>
                    Keypad.ModalBackgroundProperty = DependencyProperty.Register("ModalBackground", null);
                    Keypad.staticConstructor = (function () {
                        Keypad.TitleProperty = DependencyProperty.Register("Title", new System.Windows.PropertyMetadata("Keypad"));
                        Keypad.MinimumProperty = DependencyProperty.Register("Minimum", null);
                        Keypad.MaximumProperty = DependencyProperty.Register("Maximum", null);
                        Keypad.LeftProperty = DependencyProperty.Register("Left", new System.Windows.PropertyMetadata(Keypad.OnLeftPropertyChanged));
                        Keypad.TopProperty = DependencyProperty.Register("Top", new System.Windows.PropertyMetadata(Keypad.OnTopPropertyChanged));
                        Keypad.ModalBackgroundProperty = DependencyProperty.Register("ModalBackground", null);
                    })();
                    return Keypad;
                }(Control));
                Controls.Keypad = Keypad;
                var KeypadValidation = /** @class */ (function () {
                    function KeypadValidation() {
                    }
                    KeypadValidation.resetTooltipPosition = function () {
                        var input = $('#Keypad #Input');
                        clearTimeout(KeypadValidation.handler);
                        KeypadValidation.handler = setTimeout(function () { return input.tooltip("show"); }, 100);
                    };
                    KeypadValidation.destroyValidationError = function () {
                        var input = $('#Keypad #Input');
                        // reset validation state color and destroy tooltip
                        input.css("border-color", "#CCC").css("background", "white");
                        input.removeAttr("title");
                        input.tooltip("destroy");
                        $(window).off("resize", KeypadValidation.resetTooltipPosition);
                    };
                    KeypadValidation.ShowValidationError = function (errMsg) {
                        var input = $('#Keypad #Input');
                        if (!System.String.IsNullOrEmpty(errMsg)) {
                            input.css("border-color", "red").css("background", "pink");
                            input.tooltip("destroy");
                            input.tooltip({
                                position: { my: 'center top', at: 'center bottom' },
                                tooltipClass: "tooltipError",
                                template: '<div class="tooltip" role="tooltip"><div class="tooltip-inner"></div></div>',
                                placement: 'top',
                                trigger: 'hover',
                                title: errMsg
                            });
                            input.tooltip("show");
                            $(window).on("resize", KeypadValidation.resetTooltipPosition);
                        }
                        else {
                            KeypadValidation.destroyValidationError();
                        }
                    };
                    KeypadValidation.ValidateString = function (value, instance) {
                        var errMsg = null;
                        var d = 0;
                        var kp = instance;
                        var isNum = true;
                        if (instance.NumericFormat != "showExponent" && instance.NumericFormat != "decimal" && instance.NumericFormat != "floatingPoint" && instance.NumericFormat != undefined) {
                            try {
                                var format = 10;
                                switch (instance.NumericFormat) {
                                    case "hexadecimal":
                                        format = 16;
                                        break;
                                    case "octal":
                                        format = 8;
                                        break;
                                    case "binary":
                                        format = 2;
                                        break;
                                }
                                var v = Convert.ToInt64(value, format);
                                d = v;
                            }
                            catch (_) {
                                isNum = false;
                            }
                        }
                        else {
                            isNum = (function () {
                                var _tmp = Double.TryParse(value, null, System.Globalization.CultureInfo.CurrentCulture.NumberFormat, d);
                                d = _tmp.refs[0];
                                if (_tmp.result == false) {
                                    if (value.length > 1 && (value[value.length - 1] == 'e' || value[value.length - 1] == 'E')) {
                                        if (value.indexOf('e') == (value.length - 1) && value.indexOf('E') == -1 || value.indexOf('E') == (value.length - 1) && value.indexOf('e') == -1) {
                                            _tmp = Double.TryParse(value + '0', null, System.Globalization.CultureInfo.CurrentCulture.NumberFormat, d);
                                            d = _tmp.refs[0];
                                        }
                                    }
                                }
                                return _tmp.result;
                            }).apply(this);
                        }
                        if (value == '' || value == '-' || value == '+')
                            isNum = true;
                        if (!isNum) {
                            // Jwang fix DFCTS00358858
                            if (instance.NumericFormat != undefined)
                                errMsg = System.String.Format("Value entered in not a valid {0} type", instance.NumericFormat.toString());
                            else
                                errMsg = "Value entered in not a valid type";
                        }
                        else {
                            if (!Double.IsNaN(kp.Minimum) && d < kp.Minimum) {
                                errMsg = System.String.Format("Value can not be less than {0}", ViewPoint.Util.CommonUtilities.ReplaceSeparator(kp.Minimum.toString()) + "");
                            }
                            else if (!Double.IsNaN(kp.Maximum) && d > kp.Maximum) {
                                errMsg = System.String.Format("Value can not be greater than {0}", ViewPoint.Util.CommonUtilities.ReplaceSeparator(kp.Maximum.toString()) + "");
                            }
                            else if (instance.NumericFormat == "decimal" && (value.toString().indexOf('.') > -1)) {
                                errMsg = "Value entered in not a valid decimal type";
                            }
                        }
                        KeypadValidation.ShowValidationError(errMsg);
                        if (!System.String.IsNullOrEmpty(errMsg)) {
                            return false;
                        }
                        else {
                            if (kp.CustomValidator != null) {
                                return kp.CustomValidator.raise(value, instance);
                            }
                            return true;
                        }
                    };
                    /**
                     * Validation for NumericInput control.
                     * This method is copied from {@link ViewPoint.Client.Controls.NumericInputValidation.ValidateInput}
                     * Keypad and scratchpad fix, Patrick.
                     * @see ViewPoint.Client.Controls.NumericInputValidation.ValidateInput
                     */
                    KeypadValidation.ValidateNumericInput = function (value, instance) {
                        var errMsg = "";
                        var keypad = instance;
                        var numericInput = keypad.TriggerObject;
                        var d = 0;
                        var isNum = true;
                        console.log("Validating string of NumericInput: " + value);
                        isNum = (function () {
                            var _tmp = numericInput.ParseInputValue(value, d);
                            d = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(numericInput);
                        if (!isNum) {
                            errMsg = System.String.Format("Value entered in not a valid {0} type", numericInput.Format.toString());
                        }
                        if (!System.Double.IsNaN(numericInput.Minimum) && d < numericInput.Minimum) {
                            var min = numericInput.Minimum.toString();
                            if (min == "") {
                                min = "0";
                            }
                            errMsg = "Value can not be less than " + ViewPoint.Util.CommonUtilities.ReplaceSeparator(min);
                        }
                        else if (!System.Double.IsNaN(numericInput.Maximum) && d > numericInput.Maximum) {
                            var max = numericInput.Maximum.toString();
                            if (max == "") {
                                max = "0";
                            }
                            errMsg = "Value can not be greater than " + ViewPoint.Util.CommonUtilities.ReplaceSeparator(max);
                        }
                        KeypadValidation.ShowValidationError(errMsg);
                        return System.String.IsNullOrEmpty(errMsg) ? true : false;
                    };
                    return KeypadValidation;
                }());
                Controls.KeypadValidation = KeypadValidation;
            })(Controls = Toolkit.Controls || (Toolkit.Controls = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Controls;
            (function (Controls) {
                var ScratchpadEnterDelegate = /** @class */ (function (_super) {
                    __extends(ScratchpadEnterDelegate, _super);
                    function ScratchpadEnterDelegate() {
                        return _super !== null && _super.apply(this, arguments) || this;
                    }
                    return ScratchpadEnterDelegate;
                }(Delegate));
                Controls.ScratchpadEnterDelegate = ScratchpadEnterDelegate;
                var Scratchpad = /** @class */ (function (_super) {
                    __extends(Scratchpad, _super);
                    function Scratchpad() {
                        var allParams = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            allParams[_i] = arguments[_i];
                        }
                        var _this = _super.call(this) || this;
                        // Resize members
                        _this.previousPos = new System.Windows.Point(0, 0);
                        _this._TestHiddenText = "";
                        $('#ScratchpadRoot #Input').val("");
                        _this._fillChar = "#";
                        _this.Shown = new EventHandler();
                        _this.Closed = new EventHandler();
                        _this.OnScratchpadEnter = new ScratchpadEnterDelegate();
                        _this._isClosing = false;
                        _this._scratchPadEnter = false;
                        _this._stringValue = "";
                        _this._popUp = null;
                        _this._canvas = null;
                        _this._modal = null;
                        _this.previousPos = new System.Windows.Point(0, 0);
                        _this.resizeDir = null;
                        _this.virtualHeight = null;
                        _this.virtualWidth = null;
                        _this.m_root = null;
                        _this.m_drag = null;
                        _this.m_resize = null;
                        _this.m_label = null;
                        _this.m_input = null;
                        _this.m_maskInput = null;
                        _this.m_valueRange = null;
                        _this.CustomValidator = null;
                        // exclude microsoft surface as a mobile device
                        _this.isMobile = MobileUtility.IsMobile() && !/Windows NT.*Touch/i.test(navigator.userAgent);
                        switch (arguments.length) {
                            case 0:
                                _this.constructor_1();
                                break;
                            case 1:
                                _this.constructor_2(arguments[0]);
                                break;
                            default: throw "Invalid overload call for: constructor";
                        }
                        return _this;
                    }
                    Object.defineProperty(Scratchpad.prototype, "Title", {
                        //region Properties
                        //region Title
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Scratchpad.TitleProperty);
                        },
                        //region Properties
                        //region Title
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Scratchpad.TitleProperty, value);
                            var scapeValue = CurrentBrowser.UnicodeEscape(value);
                            $('#ScratchpadRoot #Label').text(scapeValue);
                            $('#ScratchpadRoot #Label').attr("title", scapeValue);
                            Scratchpad.FitTitle(this);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "Minimum", {
                        //region Minimum
                        get: function () {
                            return this.GetValue(Scratchpad.MinimumProperty);
                        },
                        //region Minimum
                        set: function (value) {
                            this.SetValue(Scratchpad.MinimumProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "Maximum", {
                        //region Maximum
                        get: function () {
                            return this.GetValue(Scratchpad.MaximumProperty);
                        },
                        //region Maximum
                        set: function (value) {
                            this.SetValue(Scratchpad.MaximumProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "Left", {
                        //region Left
                        /// <summary>
                        /// Gets or sets the distance from the left side of the window to the left side of its container.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Scratchpad.LeftProperty);
                        },
                        //region Left
                        /// <summary>
                        /// Gets or sets the distance from the left side of the window to the left side of its container.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Scratchpad.LeftProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "Top", {
                        //region Top
                        /// <summary>
                        /// Gets or sets the distance from the top side of the window to the top side of its container.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Scratchpad.TopProperty);
                        },
                        //region Top
                        /// <summary>
                        /// Gets or sets the distance from the top side of the window to the top side of its container.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Scratchpad.TopProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "ModalBackground", {
                        //region ModalBackground
                        /// <summary>
                        /// Gets or sets the brushed used on the background when showing a modal window.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Scratchpad.ModalBackgroundProperty);
                        },
                        //region ModalBackground
                        /// <summary>
                        /// Gets or sets the brushed used on the background when showing a modal window.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Scratchpad.ModalBackgroundProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "TextAlignment", {
                        //region TextAlignment
                        get: function () {
                            return this.GetValue(Scratchpad.TextAlignmentProperty);
                        },
                        //region TextAlignment
                        set: function (value) {
                            this.SetValue(Scratchpad.TextAlignmentProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "Display", {
                        get: function () {
                            return this._display;
                        },
                        set: function (value) {
                            this._display = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "InitialKeyStroke", {
                        /// <summary>
                        /// If set prior to show, this value will be the inital value shown in the key input
                        /// </summary>
                        get: function () {
                            return this._initialKeyStroke;
                        },
                        /// <summary>
                        /// If set prior to show, this value will be the inital value shown in the key input
                        /// </summary>
                        set: function (value) {
                            this._initialKeyStroke = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "InputLength", {
                        /// <summary>
                        /// Input length of the entry
                        /// </summary>
                        get: function () {
                            return this._inputLength;
                        },
                        /// <summary>
                        /// Input length of the entry
                        /// </summary>
                        set: function (value) {
                            this._inputLength = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "IsMaskInput", {
                        get: function () {
                            return this._isMaskInput;
                        },
                        set: function (value) {
                            if (value && MobileUtility.IsMobile()) {
                                $('#ScratchpadRoot #Input').attr("type", "password");
                            }
                            else {
                                $('#ScratchpadRoot #Input').attr("type", "text");
                            }
                            this._isMaskInput = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "TriggerObject", {
                        /// <summary>
                        /// Object that created this control.  Used to position the Scratchpad control.
                        /// </summary>
                        get: function () {
                            return this._triggerObject;
                        },
                        /// <summary>
                        /// Object that created this control.  Used to position the Scratchpad control.
                        /// </summary>
                        set: function (value) {
                            this._triggerObject = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "ClipPoint", {
                        /// <summary>
                        /// Clip point.  Set to determine where to start the modal canvas for this popup.
                        /// </summary>
                        get: function () {
                            return this._clipPoint;
                        },
                        /// <summary>
                        /// Clip point.  Set to determine where to start the modal canvas for this popup.
                        /// </summary>
                        set: function (value) {
                            this._clipPoint = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "IsNumericScratchPad", {
                        get: function () {
                            return this._isNumericScratchPad;
                        },
                        set: function (value) {
                            this._isNumericScratchPad = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Scratchpad.prototype, "StringValue", {
                        // Do not call this property directly as it is bound to the Text property of the TextBox
                        get: function () {
                            return this._stringValue;
                        },
                        // Do not call this property directly as it is bound to the Text property of the TextBox
                        set: function (value) {
                            // Keypad and scratchpad fix, Patrick
                            // Use a different validation for StringInput control
                            if (this.IsStringInputControl) {
                                ScratchpadValidation.ValidateStringInput(value, this);
                            }
                            else {
                                ScratchpadValidation.ValidateString(value, this);
                            }
                            this._stringValue = value;
                            if (!this.IsMaskInput) {
                                $('#ScratchpadRoot #Input').val(value);
                            }
                            console.log("Value changing to = " + value.toString());
                        },
                        enumerable: true,
                        configurable: true
                    });
                    //region VisualStates Groups
                    Scratchpad.prototype.ChangeVisualStateOpen = function (useTransitions) {
                        if (this._isClosing) {
                            ViewPoint.Client.Toolkit.Utilities.VisualStateHelper.GoToState(this, "Closed", useTransitions);
                            var dlg = $("#ScratchpadRoot");
                            dlg.modal("hide");
                            this.OnCloseComplete(this, null);
                        }
                        else {
                            ViewPoint.Client.Toolkit.Utilities.VisualStateHelper.GoToState(this, "Open", useTransitions);
                        }
                    };
                    //region property changes
                    Scratchpad.prototype.OnLeftChanged = function () {
                        this.SetValue(Canvas.LeftProperty, this.Left);
                    };
                    Scratchpad.prototype.OnTopChanged = function () {
                        this.SetValue(Canvas.TopProperty, this.Top);
                    };
                    //region resizing
                    Scratchpad.prototype.ResizeMouseDown = function (pos) {
                        this.m_resize.CaptureMouse();
                        this.previousPos = pos;
                        this.resizeDir = this.ResizeDir(pos);
                        this.Width = this.virtualWidth = this.ActualWidth;
                        this.Height = this.virtualHeight = this.ActualHeight;
                    };
                    Scratchpad.prototype.ResizeMouseMove = function (pos) {
                        if (this.resizeDir != new System.Windows.Point(0, 0)) {
                            var resize = new System.Windows.Point(this.resizeDir.X * (pos.X - this.previousPos.X), this.resizeDir.Y * (pos.Y - this.previousPos.Y));
                            this.virtualWidth += resize.X;
                            this.virtualHeight += resize.Y;
                            var actualResize = new System.Windows.Point(this.BoundWidth(this.virtualWidth) - this.Width, this.BoundHeight(this.virtualHeight) - this.Height);
                            this.Width += actualResize.X;
                            this.Height += actualResize.Y;
                            if (this.resizeDir.X < 0)
                                this.Left -= actualResize.X;
                            if (this.resizeDir.Y < 0)
                                this.Top -= actualResize.Y;
                            this.previousPos = new System.Windows.Point(pos.X + (this.resizeDir.X < 0 ? actualResize.X : 0), pos.Y + (this.resizeDir.Y < 0 ? actualResize.Y : 0));
                        }
                        else {
                            var dir = this.ResizeDir(pos);
                            if (dir.X != 0 && dir.Y != 0)
                                this.m_resize.Cursor = Cursors.Hand;
                            else if (dir.X != 0)
                                this.m_resize.Cursor = Cursors.SizeWE;
                            else if (dir.Y != 0)
                                this.m_resize.Cursor = Cursors.SizeNS;
                            else
                                this.m_resize.Cursor = Cursors.Arrow;
                        }
                    };
                    Scratchpad.prototype.ResizeMouseUp = function () {
                        this.m_resize.ReleaseMouseCapture();
                        this.resizeDir = new System.Windows.Point(0, 0);
                    };
                    // returns the direction of resize corresponding to a mouse position inside the window
                    // the return type is a Point used as a vector
                    Scratchpad.prototype.ResizeDir = function (pos) {
                        var dir = new System.Windows.Point(0, 0);
                        if (pos.X < this.m_resize.BorderThickness.Left)
                            dir.X = -1;
                        else if (pos.X >= this.m_resize.ActualWidth - this.m_resize.BorderThickness.Right)
                            dir.X = 1;
                        if (pos.Y < this.m_resize.BorderThickness.Top)
                            dir.Y = -1;
                        else if (pos.Y >= this.m_resize.ActualHeight - this.m_resize.BorderThickness.Bottom)
                            dir.Y = 1;
                        return dir;
                    };
                    // returns the width bounded to the minimum and maximum width of the window
                    Scratchpad.prototype.BoundWidth = function (width) {
                        return Math.max(width, this.m_root.MinWidth);
                    };
                    // returns the height bounded to the minimum and maximum width of the height
                    Scratchpad.prototype.BoundHeight = function (height) {
                        return Math.max(height, this.m_root.MinHeight);
                    };
                    Scratchpad.prototype.OnApplyTemplate = function () {
                        _super.prototype.OnApplyTemplate.call(this);
                        // Get the elements
                        this.m_root = this.GetTemplateChild(Scratchpad.RootElementName);
                        this.m_root.DataContext = this;
                        this.m_drag = this.GetTemplateChild(Scratchpad.DragElementName);
                        this.m_resize = this.GetTemplateChild(Scratchpad.ResizeElementName);
                        this.m_label = this.GetTemplateChild(Scratchpad.LabelElementName);
                        this.m_input = this.GetTemplateChild(Scratchpad.InputElementName);
                        this.m_maskInput = this.GetTemplateChild(Scratchpad.MaskInputElementName);
                        this.m_valueRange = this.GetTemplateChild(Scratchpad.ValueRangeElementName);
                        this.m_input.KeyDown.subscribe(this.Input_KeyDown, this);
                        //this.m_input.KeyUp.subscribe(this.Input_KeyUp, this);
                        this.m_input.TextChanged.subscribe(this.Input_TextChanged, this);
                        // The mask input is only used for a string scratch pad.
                        this.m_maskInput.KeyDown.subscribe(this.Input_KeyDown, this);
                        //this.m_maskInput.KeyUp.subscribe(this.Input_KeyUp, this);
                        this.m_maskInput.PasswordChanged.subscribe(this.MaskInput_PasswordChanged, this);
                        this.m_maskInput.PasswordChar = "#";
                        this.InitializeDragPart();
                        this.InitializeResizePart();
                        this.ChangeVisualStateOpen(true);
                    };
                    Scratchpad.prototype.Initialize = function () {
                        if (this._canvas == null) {
                            this._modal = new System.Windows.Shapes.Rectangle();
                            this._canvas = new System.Windows.Controls.Canvas();
                            this._canvas.SizeChanged.subscribe(this.CanvasSizeChanged, this);
                            this._canvas.SetValue(Canvas.ZIndexProperty, Scratchpad.ZIndex);
                            this._popUp = (function () {
                                var _tmp = new System.Windows.Controls.Primitives.Popup;
                                _tmp.Child = this._canvas;
                                _tmp.IsOpen = true;
                                return _tmp;
                            })();
                            this._popUp.Closed.subscribe(this.PopUp_Closed, this);
                            this.AttachControl();
                        }
                        this.IsHitTestVisible = true;
                        this.Loaded.subscribe(this.Scratchpad_Loaded, this);
                        this.MouseLeftButtonDown.subscribe(function (s, e) {
                            this.m_input.Focus();
                        }, this);
                    };
                    /// <summary>
                    /// The popup was closed outside of this class.  Use this to clean up.
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    Scratchpad.prototype.PopUp_Closed = function (sender, e) {
                        this.OnCloseComplete(sender, e);
                        if (this.Display != null) {
                            this.Display.Children.Remove(this._popUp);
                        }
                    };
                    Scratchpad.prototype.CanvasSizeChanged = function (sender, e) {
                        if (this.Left + this.ActualWidth + this.ClipPoint.X > this._canvas.ActualWidth) {
                            this.Left = this._canvas.ActualWidth - this.ActualWidth - this.ClipPoint.X;
                        }
                        if (this.Top + this.ActualHeight + this.ClipPoint.Y > this._canvas.ActualHeight) {
                            this.Top = this._canvas.ActualHeight - this.ActualHeight - this.ClipPoint.Y;
                        }
                        if (this.Left < this.ClipPoint.X) {
                            this.Left = this.ClipPoint.X;
                        }
                        if (this.Top < this.ClipPoint.Y) {
                            this.Top = this.ClipPoint.Y;
                        }
                        this._modal.Width = this._canvas.ActualWidth;
                        this._modal.Height = this._canvas.ActualHeight;
                        this._canvas.Clip = (function () {
                            var _tmp = new System.Windows.Media.RectangleGeometry;
                            _tmp.Rect = new System.Windows.Rect(this.ClipPoint.X, this.ClipPoint.Y, this._canvas.ActualWidth - this.ClipPoint.X, this._canvas.ActualHeight - this.ClipPoint.Y);
                            return _tmp;
                        })();
                    };
                    Scratchpad.prototype.AttachControl = function () {
                        if (this.Display != null) {
                            this.Display.Children.Add(this._popUp);
                            this.Display.SizeChanged.subscribe(this.Content_Resized, this);
                        }
                        else {
                            Application.Current.Host.Content.Resized.subscribe(this.Content_Resized, this);
                        }
                        this.Content_Resized(null, null);
                    };
                    Scratchpad.prototype.Input_TextChanged = function (sender, e) {
                        this.ValidateInput();
                    };
                    Scratchpad.prototype.MaskInput_PasswordChanged = function (sender, e) {
                        this.ValidateMaskInput();
                    };
                    Scratchpad.prototype.ValidateInput = function () {
                        var str = $('#ScratchpadRoot #Input').val();
                        var result = false;
                        // Keypad and scratchpad fix, Patrick
                        // Use a different validation for StringInput control
                        if (this.IsStringInputControl) {
                            result = ScratchpadValidation.ValidateStringInput(str, this);
                        }
                        else {
                            result = ScratchpadValidation.ValidateString(str, this);
                        }
                        this.StringValue = str;
                        return result;
                    };
                    Scratchpad.prototype.ValidateMaskInput = function () {
                        var str;
                        if (MobileUtility.IsMobile()) {
                            str = $('#ScratchpadRoot #Input').val();
                        }
                        else {
                            str = this._TestHiddenText;
                        }
                        var result = false;
                        // Keypad and scratchpad fix, Patrick
                        // Use a different validation for StringInput control
                        if (this.IsStringInputControl) {
                            result = ScratchpadValidation.ValidateStringInput(str, this);
                        }
                        else {
                            result = ScratchpadValidation.ValidateString(str, this);
                        }
                        this.StringValue = str;
                        return result;
                    };
                    Scratchpad.prototype.Input_KeyPressed = function (sender, e) {
                        var key = e.Key;
                        var input = $('#ScratchpadRoot #Input');
                        if (key == KeyInput.Escape) {
                            this._isClosing = true;
                            this.ChangeVisualStateOpen(true);
                        }
                        else if (key == KeyInput.Enter) {
                            var hasError;
                            // Validate
                            if (this.IsMaskInput) {
                                hasError = !this.ValidateMaskInput();
                            }
                            else {
                                hasError = !this.ValidateInput();
                            }
                            if (hasError == false) {
                                this._isClosing = true;
                                this._scratchPadEnter = true;
                                this.ChangeVisualStateOpen(true);
                                e.Handled = true;
                            }
                        }
                        else if (this.IsMaskInput && !MobileUtility.IsMobile()) {
                            this.HandleIsMaskInput(key, input, e);
                        }
                        else if (this.IsNumericScratchPad) {
                            this.HandleIsNumericScratchPad(key, e);
                        }
                        return e.Handled;
                    };
                    Scratchpad.prototype.Masked_Input_Paste_Handle = function (text) {
                        // JWANG DFCTS00359206 [Mobile][CMN][String Input]Cannot paste value to String input popup 
                        if (this.IsMaskInput && !MobileUtility.IsMobile()) {
                            var input = $('#ScratchpadRoot #Input');
                            if (input && typeof (text) == "string") {
                                var previousPosition = input.prop("selectionStart");
                                this.StringValue = this.StringValue.Insert(previousPosition, text);
                                this._TestHiddenText = this.StringValue;
                                var position = previousPosition + text.length;
                                input.prop("selectionStart", position);
                                if (this.StringValue != undefined)
                                    input.val(Array(this.StringValue.length + 1).join("#"));
                                return true;
                            }
                        }
                        return false;
                    };
                    Scratchpad.prototype.HandleIsNumericScratchPad = function (key, e) {
                        // If this control is a numeric scratch pad, then the m_input textbox will be visible
                        // handle minus/subtract key
                        if (key == KeyInput.Subtract || (key == KeyInput.Unknown && e.PlatformKeyCode == 189)) {
                            var negative = Convert.ToString("-", CultureInfo.CurrentCulture);
                            if (this.StringValue.length > 1 || (this.StringValue.length == 1 && System.String.Compare(this.StringValue, "0", StringComparison.CurrentCulture) != 0)) {
                                var previousPosition = this.m_input.SelectionStart;
                                if (System.String.Compare(this.StringValue.substr(0, 1), negative, StringComparison.CurrentCulture) == 0) {
                                    this.StringValue = this.StringValue.substr(1, this.StringValue.length - 1);
                                    if (this.IsMaskInput)
                                        previousPosition -= 1;
                                }
                                else {
                                    // since we are manually inserting text, make sure we don't exceed the input length
                                    if (this.InputLength != 0 && this.StringValue.length + 1 <= this.InputLength) {
                                        this.StringValue = this.StringValue.Insert(0, negative);
                                        previousPosition += 1;
                                    }
                                }
                                this.m_input.SelectionStart = previousPosition;
                            }
                            e.Handled = true;
                        }
                        else if (!((KeyInput.D0 <= key && key <= KeyInput.D9) || (KeyInput.NumPad0 <= key && key <= KeyInput.NumPad9))) {
                            e.Handled = true;
                        }
                    };
                    Scratchpad.prototype.HandleIsMaskInput = function (key, input, e) {
                        if (/\S| /g.test(String.fromCharCode(key))) {
                            if (input.val().length < this.InputLength) {
                                this._TestHiddenText += String.fromCharCode(key);
                                input.val(input.val() + this._fillChar);
                            }
                            e.Handled = true;
                        }
                    };
                    Scratchpad.prototype.Input_KeyDown = function (sender, e) {
                        var key = e.Key;
                        var input = $('#ScratchpadRoot #Input');
                        if (key == KeyInput.Escape) {
                            this._isClosing = true;
                            this.ChangeVisualStateOpen(true);
                            e.Handled = true;
                        }
                        else if (key == KeyInput.Delete) {
                            if (this.IsMaskInput) {
                                this._TestHiddenText = "";
                            }
                            input.val("");
                            e.Handled = true;
                        }
                        else if (key == KeyInput.Enter) {
                            var hasError;
                            // Validate
                            if (this.IsMaskInput) {
                                hasError = !this.ValidateMaskInput();
                            }
                            else {
                                hasError = !this.ValidateInput();
                            }
                            if (hasError == false) {
                                this._isClosing = true;
                                this._scratchPadEnter = true;
                                this.ChangeVisualStateOpen(true);
                                e.Handled = true;
                            }
                        }
                        else if (key == KeyInput.Back && !MobileUtility.IsMobile()) {
                            if (this.IsMaskInput) {
                                this._TestHiddenText = this._TestHiddenText.slice(0, -1);
                                input.val(input.val().slice(0, -1));
                                e.Handled = true;
                            }
                        }
                        return e.Handled;
                    };
                    // Keypad and scratchpad fix begin, Patrick
                    Scratchpad.prototype.KeyDown_Window = function (event) {
                        var keyEvent = new System.Windows.Input.KeyEventArgs(event.keyCode);
                        if (this.Input_KeyDown(null, keyEvent)) {
                            event.preventDefault();
                        }
                    };
                    // bind to `ng-click` directive, when click 'ok' button to submit string input
                    // @see: Scratchpad#Input_KeyPressed
                    Scratchpad.prototype.Submit_Change = function (sender, e) {
                        var hasError;
                        // Validate
                        if (this.IsMaskInput) {
                            hasError = !this.ValidateMaskInput();
                        }
                        else {
                            hasError = !this.ValidateInput();
                        }
                        if (hasError == false) {
                            this._isClosing = true;
                            this._scratchPadEnter = true;
                            this.ChangeVisualStateOpen(true);
                        }
                        e.Handled = true;
                        return e.Handled;
                    };
                    // bind to `ng-click` directive, when click 'cancel' button to cancel string input
                    // @see: Scratchpad#Input_KeyDown
                    Scratchpad.prototype.Cancel_Change = function (sender, e) {
                        this._isClosing = true;
                        this.ChangeVisualStateOpen(true);
                        e.Handled = true;
                        return e.Handled;
                    };
                    // Keypad and scratchpad fix end, Patrick
                    Scratchpad.prototype.Content_Resized = function (sender, e) {
                        if (this.Display != null) {
                            this._canvas.Width = this.Display.ActualWidth;
                            this._canvas.Height = this.Display.ActualHeight;
                        }
                        else {
                            this._canvas.Width = Application.Current.Host.Content.ActualWidth;
                            this._canvas.Height = Application.Current.Host.Content.ActualHeight;
                        }
                    };
                    Scratchpad.prototype.Scratchpad_Loaded = function (sender, e) {
                        this.ApplyTemplate();
                        this.m_input.MaxLength = this.InputLength;
                        this.m_maskInput.MaxLength = this.InputLength;
                        // Only the string scratch pad can mask its input
                        if (this.IsMaskInput && !this.IsNumericScratchPad) {
                            this.m_input.Visibility = 1 /* Collapsed */;
                            this.m_maskInput.Visibility = 0 /* Visible */;
                            this.m_maskInput.Focus();
                        }
                        else {
                            this.IsMaskInput = false;
                            this.m_input.Visibility = 0 /* Visible */;
                            this.m_maskInput.Visibility = 1 /* Collapsed */;
                            this.m_input.Focus();
                        }
                    };
                    Scratchpad.prototype.InitializeDragPart = function () {
                        /*AIS_TODO var dragHelper : MouseHelper = new ViewPoint.Client.Toolkit.Utilities.MouseHelper(this.m_drag);
                        dragHelper.RelativeTo = this.Display;
                        dragHelper.MouseDragMove.subscribe(function (s,e) {
                           var size : any = new System.Windows.Size(this._canvas.ActualWidth, this._canvas.ActualHeight);
                           var currentPoint : any = e.GetPosition(this._canvas);
                           var previousPoint : any = e.PreviousPosition;
                           // C1TransformToVisual throws when canvas is in a popup
                           if (!(lang.isType<Popup>(this._canvas.Parent))) {
                              previousPoint = Application.Current.RootVisual.TransformToVisual(this._canvas).Transform(previousPoint);
                           }
                           this.Left += Math.min(size.Width, Math.max(currentPoint.X, 0)) - Math.min(size.Width, Math.max(previousPoint.X, 0));
                           this.Top += Math.min(size.Height, Math.max(currentPoint.Y, 0)) - Math.min(size.Height, Math.max(previousPoint.Y, 0));
                           this.InvalidateMeasure();
                        }, this);*/
                    };
                    Scratchpad.prototype.InitializeResizePart = function () {
                        this.m_resize.MouseLeftButtonDown.subscribe(function (s, e) {
                            return this.ResizeMouseDown(e.GetPosition(this.m_resize));
                        }, this);
                        this.m_resize.MouseMove.subscribe(function (s, e) {
                            return this.ResizeMouseMove(e.GetPosition(this.m_resize));
                        }, this);
                        // hook from mouse enter so that the correct cursor is shown when the mouse just entered but hasn't moved yet
                        this.m_resize.MouseEnter.subscribe(function (s, e) {
                            return this.ResizeMouseMove(e.GetPosition(this.m_resize));
                        }, this);
                        this.m_resize.MouseLeftButtonUp.subscribe(function (s, e) {
                            return this.ResizeMouseUp();
                        }, this);
                    };
                    Scratchpad.prototype.OnLayout = function (a) {
                        var handler = function (s, e) {
                            a();
                            this.LayoutUpdated.unsubscribe(handler);
                        };
                        this.LayoutUpdated.subscribe(handler, this);
                        /*AIS_TODO this.InvalidateMeasure();*/
                    };
                    /// <summary>
                    /// The control is no longer valid once it closes.
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    Scratchpad.prototype.OnCloseComplete = function (sender, e) {
                        if (this.OnScratchpadEnter != null) {
                            try {
                                if (this._scratchPadEnter) {
                                    this.OnScratchpadEnter.raise(this.StringValue);
                                }
                            }
                            catch (ex) {
                                Controls.DialogBox.Show(ex.message, Controls.MessageType.Error, Controls.DialogBoxButtons.Ok);
                            }
                        }
                        if (this.Display != null) {
                            this.Display.SizeChanged.unsubscribe(this.Content_Resized);
                        }
                        else {
                            Application.Current.Host.Content.Resized.unsubscribe(this.Content_Resized);
                        }
                        this._canvas.Children.Remove(this._modal);
                        this._canvas.Children.Remove(this);
                        this._canvas.SizeChanged.unsubscribe(this.CanvasSizeChanged);
                        this._popUp.Closed.unsubscribe(this.PopUp_Closed);
                        this._popUp.IsOpen = false;
                        this._popUp.Child = null;
                        if (this.Closed != null)
                            this.Closed.raise(this, null);
                        // Keypad and scratchpad fix, Patrick
                        // Trick: hide mobile virtual keyboard after scratchpad closed
                        if (this.isMobile) {
                            document.activeElement.blur();
                            var inputs = document.querySelectorAll('input');
                            for (var i = 0; i < inputs.length; i++) {
                                inputs[i].blur();
                            }
                        }
                    };
                    Scratchpad.prototype.Show = function () {
                        var allParams = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            allParams[_i] = arguments[_i];
                        }
                        this.Focus();
                        switch (arguments.length) {
                            case 0: return this.Show_1();
                            case 1: return this.Show_2(arguments[0]);
                            default: throw "Invalid overload call for: Show";
                        }
                    };
                    Scratchpad.prototype.Show_1 = function () {
                        var _this = this;
                        this._canvas.Children.Add(this._modal);
                        this._canvas.Children.Add(this);
                        // Property set after added to UI Tree
                        this._modal.Fill = this.ModalBackground;
                        var dlg = $("#ScratchpadRoot");
                        if (/Windows NT.*Touch/i.test(navigator.userAgent)) {
                            dlg.addClass('ms-surface');
                        }
                        else {
                            dlg.removeClass('ms-surface');
                        }
                        // If no title, hide `<div id="Drag">`
                        if (this.Title) {
                            dlg
                                .find("#Drag")
                                .show()
                                .find("#Label")
                                .css("visibility", "visible");
                        }
                        else {
                            dlg
                                .find("#Drag")
                                .hide()
                                .find("#Label")
                                .css("visibility", "hidden");
                        }
                        dlg.find('#Input').attr("maxlength", this.InputLength);
                        dlg.one('shown.bs.modal', function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            _this.OnBootstrapModalShown.apply(_this, args);
                        });
                        dlg.one('hidden.bs.modal', function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            _this.onBootstrapModalHidden.apply(_this, args);
                        });
                        dlg.modal({
                            backdrop: 'static',
                            keyboard: false,
                            show: true
                        });
                        dlg.css("overflow", "hidden");
                        var area = ViewPoint.Util.CommonUtilities.CalculateDraggableArea(dlg);
                        dlg.find('#scratchPadContent').draggable({ containment: $('#DisplayArea') });
                        // Set border style
                        this.Shown.raise(this, null);
                    };
                    Scratchpad.prototype.OnBootstrapModalShown = function (event) {
                        var _this = this;
                        var dlg = $("#ScratchpadRoot");
                        // Clear input field
                        dlg.find('#Input').val("");
                        $(document).on('keydown', function () {
                            var args = [];
                            for (var _i = 0; _i < arguments.length; _i++) {
                                args[_i] = arguments[_i];
                            }
                            _this.KeyDown_Window.apply(_this, args);
                        });
                        if (!dlg.find('#scratchPadContent').hasClass('ui-resizable') && !this.isMobile) {
                            dlg.find('#scratchPadContent').resizable({
                                minHeight: dlg.find('.modal-content').height(),
                                minWidth: dlg.find('.modal-content').width(),
                                handles: 'all'
                            });
                        }
                        var buttons = dlg.find(".modal-footer button");
                        buttons.css("background-color", "transparent");
                        setTimeout(function () { return dlg.find("#Input").focus(); }, 200);
                    };
                    Scratchpad.prototype.onBootstrapModalHidden = function (event) {
                        var dlg = $("#ScratchpadRoot");
                        $(document).off('keydown');
                    };
                    Scratchpad.prototype.OnClickFocusInput = function () {
                        var Scratchpad = $("#ScratchpadRoot");
                        var input = Scratchpad.find("#Input");
                        if (input.length == 1)
                            input.focus();
                    };
                    Scratchpad.prototype.OnResizeFixPosition = function () {
                        var Scratchpad = $("#ScratchpadRoot");
                        var position = Scratchpad.position();
                        if (position.left + Scratchpad.outerWidth() > $(window).width()) {
                            Scratchpad.css("left", $(window).width() - Scratchpad.outerWidth());
                        }
                        var StatusBar = $("#StatusBar");
                        var StatusBarHeight = StatusBar.height();
                        var Splitter = $("#GridSplitter .hsplitter");
                        var SplitterHeight = Splitter.height();
                        if (position.top + Scratchpad.outerHeight() > $(window).height() - StatusBarHeight - SplitterHeight) {
                            Scratchpad.css("top", $(window).height() - StatusBarHeight - Scratchpad.outerHeight() - SplitterHeight);
                        }
                    };
                    Scratchpad.prototype.Show_2 = function (key) {
                        this.InitialKeyStroke = key;
                        this.Show();
                    };
                    Scratchpad.OnLeftPropertyChanged = function (d, e) {
                        var sender = lang.asType(d);
                        // Call the hook method if is required
                        sender.OnLeftChanged();
                    };
                    Scratchpad.OnTopPropertyChanged = function (d, e) {
                        var sender = lang.asType(d);
                        // Call the hook method if is required
                        sender.OnTopChanged();
                    };
                    Scratchpad.OnTitleChanged = function (d, e) {
                        var sender = lang.asTypeT(d, Scratchpad);
                        if (sender != null) {
                            Scratchpad.FitTitle(sender);
                        }
                    };
                    Scratchpad.FitTitle = function (ScratchpadInstance) {
                        var ScratchpadControl = $('#Scratchpad');
                        var Label = ScratchpadControl.find('#Label');
                        var ScratchpadRoot = ScratchpadControl.find('#ScratchpadRoot');
                        var ScratchPadContent = ScratchpadControl.find('.scratchPadContent');
                        var scapeValue = CurrentBrowser.UnicodeEscape(ScratchpadInstance.Title);
                        Label.text(scapeValue);
                        Label.attr("title", scapeValue);
                        var textTittle = Label.clone();
                        textTittle.removeAttr("overflow").css('width', 'auto').css("position", "absolute").css("white-space", "nowrap").attr("top", -9999).attr("left", -9999);
                        textTittle.appendTo("body");
                        var newWidth = textTittle.width();
                        textTittle.remove();
                        if (newWidth <= 150) {
                            newWidth = 150;
                        }
                        // Keypad and scratchpad fix, Patrick
                        //ScratchpadRoot.width(newWidth + 27);
                        //ScratchPadContent.width(newWidth + 15);
                    };
                    Scratchpad.prototype.constructor_1 = function () {
                        this.DefaultStyleKey = lang.typeOf();
                        this.Initialize();
                    };
                    Scratchpad.prototype.constructor_2 = function (p) {
                        this.DefaultStyleKey = lang.typeOf();
                        this.Display = p;
                        this.Initialize();
                    };
                    // this value must be negative so that users can open tooltips and popup over windows
                    Scratchpad.ZIndex = -10000;
                    Scratchpad.RootElementName = "Root";
                    Scratchpad.DragElementName = "Drag";
                    Scratchpad.ResizeElementName = "Resize";
                    Scratchpad.LabelElementName = "Label";
                    Scratchpad.InputElementName = "Input";
                    Scratchpad.MaskInputElementName = "MaskInput";
                    Scratchpad.ValueRangeElementName = "ValueRange";
                    /// <summary>
                    /// Identifies the <see cref="ShowCloseButton"/> dependency property. 
                    /// </summary>
                    Scratchpad.TitleProperty = DependencyProperty.Register("Title", new System.Windows.PropertyMetadata(Scratchpad.OnTitleChanged));
                    Scratchpad.MinimumProperty = DependencyProperty.Register("Minimum", null);
                    Scratchpad.MaximumProperty = DependencyProperty.Register("Maximum", null);
                    /// <summary>
                    /// Identifies the <see cref="Left"/> dependency property. 
                    /// </summary>
                    Scratchpad.LeftProperty = DependencyProperty.Register("Left", new System.Windows.PropertyMetadata(Scratchpad.OnLeftPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="Top"/> dependency property. 
                    /// </summary>
                    Scratchpad.TopProperty = DependencyProperty.Register("Top", new System.Windows.PropertyMetadata(Scratchpad.OnTopPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="ModalBackground"/> dependency property. 
                    /// </summary>
                    Scratchpad.ModalBackgroundProperty = DependencyProperty.Register("ModalBackground", null);
                    Scratchpad.TextAlignmentProperty = DependencyProperty.Register("TextAlignment", null);
                    Scratchpad.staticConstructor = (function () {
                        Scratchpad.TitleProperty = DependencyProperty.Register("Title", new System.Windows.PropertyMetadata(Scratchpad.OnTitleChanged));
                        Scratchpad.MinimumProperty = DependencyProperty.Register("Minimum", null);
                        Scratchpad.MaximumProperty = DependencyProperty.Register("Maximum", null);
                        Scratchpad.LeftProperty = DependencyProperty.Register("Left", new System.Windows.PropertyMetadata(Scratchpad.OnLeftPropertyChanged));
                        Scratchpad.TopProperty = DependencyProperty.Register("Top", new System.Windows.PropertyMetadata(Scratchpad.OnTopPropertyChanged));
                        Scratchpad.ModalBackgroundProperty = DependencyProperty.Register("ModalBackground", null);
                        Scratchpad.TextAlignmentProperty = DependencyProperty.Register("TextAlignment", null);
                    })();
                    return Scratchpad;
                }(Control));
                Controls.Scratchpad = Scratchpad;
                var ScratchpadValidation = /** @class */ (function () {
                    function ScratchpadValidation() {
                    }
                    ScratchpadValidation.ValidateString = function (value, instance) {
                        var errMsg = null;
                        var d = 0;
                        var sp = instance;
                        if (sp.IsNumericScratchPad) {
                            var isNum = (function () {
                                var _tmp = Double.TryParse(value, d);
                                d = _tmp.refs[0];
                                return _tmp.result;
                            }).apply(this);
                            if (!isNum) {
                                errMsg = "Value entered in not a valid type";
                            }
                            else {
                                if (!Double.IsNaN(sp.Minimum) && d < sp.Minimum) {
                                    errMsg = System.String.Format("Value can not be less than {0}", ViewPoint.Util.CommonUtilities.ReplaceSeparator(sp.Minimum.toString()));
                                }
                                else if (!Double.IsNaN(sp.Maximum) && d > sp.Maximum) {
                                    errMsg = System.String.Format("Value can not be greater than {0}", ViewPoint.Util.CommonUtilities.ReplaceSeparator(sp.Maximum.toString()));
                                }
                            }
                        }
                        if (!System.String.IsNullOrEmpty(errMsg)) {
                            return false;
                        }
                        else {
                            if (sp.CustomValidator != null) {
                                return sp.CustomValidator.raise(value, instance);
                            }
                            return true;
                        }
                    };
                    /**
                     * Validation for StringInput control. But it seems to do nothing for this kind of control.
                     * Keypad and scratchpad fix, Patrick.
                     * @see ViewPoint.Client.Controls.StringInputValidation#ValidateInput
                     */
                    ScratchpadValidation.ValidateStringInput = function (value, instance) {
                        var errMsg = "";
                        return System.String.IsNullOrEmpty(errMsg) ? true : false;
                    };
                    return ScratchpadValidation;
                }());
                Controls.ScratchpadValidation = ScratchpadValidation;
            })(Controls = Toolkit.Controls || (Toolkit.Controls = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Controls;
            (function (Controls) {
                var Status = /** @class */ (function () {
                    function Status(type, message, details) {
                        this.Type = type;
                        switch (type) {
                            case Controls.MessageType.Error:
                                this.StatusBrush = new System.Windows.Media.SolidColorBrush(Colors.Red);
                                break;
                            case Controls.MessageType.Information:
                                this.StatusBrush = new System.Windows.Media.SolidColorBrush(Colors.Blue);
                                break;
                            case Controls.MessageType.Warning:
                                this.StatusBrush = new System.Windows.Media.SolidColorBrush(Colors.Yellow);
                                break;
                            default:
                                this.StatusBrush = new System.Windows.Media.SolidColorBrush(Colors.Green);
                                break;
                        }
                        this.Message = message;
                        this.ID = Guid.NewGuid().toString();
                        this.Details = details;
                    }
                    Object.defineProperty(Status.prototype, "StatusBrush", {
                        /// <summary>
                        /// The color of the status indicator
                        /// </summary>
                        get: function () {
                            return this._statusBrush;
                        },
                        /// <summary>
                        /// The color of the status indicator
                        /// </summary>
                        set: function (value) {
                            this._statusBrush = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Status.prototype, "Message", {
                        /// <summary>
                        /// Message to be displayed in the list
                        /// </summary>
                        get: function () {
                            return this._message;
                        },
                        /// <summary>
                        /// Message to be displayed in the list
                        /// </summary>
                        set: function (value) {
                            this._message = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Status.prototype, "ID", {
                        /// <summary>
                        /// Unique id assigned to eash item and remove button in the list.  Helps to delete a item that isn't selected
                        /// </summary>
                        get: function () {
                            return this._iD;
                        },
                        /// <summary>
                        /// Unique id assigned to eash item and remove button in the list.  Helps to delete a item that isn't selected
                        /// </summary>
                        set: function (value) {
                            this._iD = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Status.prototype, "Type", {
                        /// <summary>
                        /// The type of message
                        /// </summary>
                        get: function () {
                            return this._type;
                        },
                        /// <summary>
                        /// The type of message
                        /// </summary>
                        set: function (value) {
                            this._type = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Status.prototype, "Details", {
                        /// <summary>
                        /// Additional details about the error message.  This information will be displayed in a DialogBox
                        /// </summary>
                        get: function () {
                            return this._details;
                        },
                        /// <summary>
                        /// Additional details about the error message.  This information will be displayed in a DialogBox
                        /// </summary>
                        set: function (value) {
                            this._details = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    return Status;
                }());
                Controls.Status = Status;
            })(Controls = Toolkit.Controls || (Toolkit.Controls = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Controls;
            (function (Controls) {
                var StatusBar = /** @class */ (function (_super) {
                    __extends(StatusBar, _super);
                    function StatusBar() {
                        var _this = _super.call(this) || this;
                        _this.m_statusList = null;
                        _this.m_lastTime = null;
                        // Required to initialize variables
                        _this.m_statusList = new Array();
                        //this.m_statusList.CollectionChanged.subscribe(this.CollectionChanged, this);
                        _this.List = new ListBox(); //AIS_TODO this one should only goes on the InitializeComponent functionS
                        //this.List.ItemsSource = <System.Collections.IEnumerable>this.m_statusList;
                        _this.m_lastTime = new System.DateTime();
                        _this.List.MouseWheel.subscribe(_this.List_MouseWheel, _this);
                        _this.List.KeyDown.subscribe(_this.List_KeyDown, _this);
                        ViewPoint.Client.Toolkit.Controls.StatusBar.statusBar = _this;
                        return _this;
                    }
                    StatusBar.prototype.List_KeyDown = function (sender, e) {
                        if (e != null) {
                            if (e.Key == KeyInput.A && ((new Keyboard).Modifiers & ModifierKeys.Control) == ModifierKeys.Control) {
                                for (var _index in this.List.Items) {
                                    var item = this.List.Items[_index];
                                    this.List.SelectedItems.Add(item);
                                }
                            }
                            else if (e.Key == KeyInput.Delete) {
                                this.DeleteAllSelected();
                            }
                        }
                    };
                    StatusBar.prototype.List_MouseWheel = function (sender, e) {
                        var peer = FrameworkElementAutomationPeer.FromElement(lang.asType(sender));
                        peer = (peer == null) ? FrameworkElementAutomationPeer.CreatePeerForElement(lang.asType(sender)) : peer;
                        var scrollProvider = lang.asType(peer.GetPattern(PatternInterface.Scroll));
                        if (scrollProvider != null) {
                            var direction = e.Delta; /*AIS-TODO Math.Sign mising in Typescript : number = Math.sign(e.Delta); */
                            var scrollAmount = (direction < 0) ? ScrollAmount.SmallIncrement : ScrollAmount.SmallDecrement;
                            if (scrollProvider.VerticallyScrollable) {
                                scrollProvider.Scroll(ScrollAmount.NoAmount, scrollAmount);
                            }
                        }
                        e.Handled = true;
                    };
                    StatusBar.prototype.CollectionChanged = function (sender, e) {
                        if (this.StatusWatermark != null) {
                            if (this.m_statusList.length == 0) {
                                this.StatusWatermark.Visibility = 0 /* Visible */;
                            }
                            else {
                                this.StatusWatermark.Visibility = 1 /* Collapsed */;
                            }
                        }
                    };
                    StatusBar.prototype.Remove = function (element, array) {
                        var ret = null;
                        for (var i = 0; i < array.length; i++) {
                            if (array[i] == element) {
                                ret = array[i];
                                array.splice(i, 1);
                                this.AngularObject.$applyAsync();
                                return ret;
                            }
                        }
                        return ret;
                    };
                    StatusBar.prototype.Insert = function (element, array) {
                        try {
                            array.splice(0, 0, element);
                            this.AngularObject.$applyAsync();
                            return element;
                        }
                        catch (e) {
                            return null;
                        }
                    };
                    StatusBar.prototype.GetElement = function (id, array) {
                        for (var ndx = 0; ndx < array.length; ndx++) {
                            if (array[ndx].ID == id) {
                                return array[ndx];
                            }
                        }
                    };
                    /// <summary>
                    /// Gets called with the FrameworkElement of the ItemTemplate gets loaded.
                    /// Note: List items get loaded/unloaded when they come in/out of view.
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    StatusBar.prototype.ItemLoaded = function (sender, e) {
                        var fe = lang.asType(sender);
                        var ni = lang.asType(fe.FindName("NormalIcon"));
                        var storyBoard = lang.asType(fe.FindName("StoryBoardError"));
                        if (fe.DataContext.Type == Controls.MessageType.Error) {
                            storyBoard.Begin();
                        }
                        else {
                            storyBoard.Stop();
                        }
                    };
                    StatusBar.prototype.DeleteAllSelected = function () {
                        while (this.List.SelectedItems.Count > 0) {
                            this.Remove(this.List.SelectedItems[0], this.m_statusList);
                        }
                    };
                    StatusBar.prototype.DeleteStatusItem = function (sender, e) {
                        //AIS TODO this.DeleteAllSelected();
                        var s;
                        var id = sender;
                        // Remove the item the user selected to delete if it wasn't selected
                        for (var ndx = 0; ndx < this.m_statusList.length; ndx++) {
                            s = lang.asTypeT(this.m_statusList[ndx], Controls.Status);
                            if (s.ID == id) {
                                this.Remove(s, this.m_statusList);
                                break;
                            }
                        }
                    };
                    StatusBar.prototype.AddStatusItem = function (status) {
                        if (status != null) {
                            this.Insert(status, this.m_statusList);
                        }
                    };
                    StatusBar.prototype.WriteMessage = function (type, message, details) {
                        this.Insert(new ViewPoint.Client.Toolkit.Controls.Status(type, message, details), this.m_statusList);
                    };
                    /// <summary>
                    /// Creates an informational message and write it to the status bar
                    /// </summary>
                    /// <param name="message">Message to display</param>
                    /// <param name="details">additional details that will be displayed in a popup dialog.  Used when more information is needed to be displayed.</param>
                    StatusBar.prototype.WriteInfoMessage = function (message, details) {
                        this.WriteMessage(Controls.MessageType.Information, message, details);
                    };
                    /// <summary>
                    /// Creates a warning message and write it to the status bar
                    /// </summary>
                    /// <param name="message">Message to display</param>
                    /// <param name="details">additional details that will be displayed in a popup dialog.  Used when more information is needed to be displayed.</param>
                    StatusBar.prototype.WriteWarningMessage = function (message, details) {
                        this.WriteMessage(Controls.MessageType.Warning, message, details);
                    };
                    /// <summary>
                    /// Creates an error message and write it to the status bar
                    /// </summary>
                    /// <param name="message">Message to display</param>
                    /// <param name="details">additional details that will be displayed in a popup dialog.  Used when more information is needed to be displayed.</param>
                    StatusBar.prototype.WriteErrorMessage = function (message, details) {
                        this.WriteMessage(Controls.MessageType.Error, message, details);
                    };
                    StatusBar.prototype.ItemSelected = function (sender, e) {
                        var fe = lang.asType(sender);
                        var storyBoard = lang.asType(fe.FindName("StoryBoardError"));
                        storyBoard.Stop();
                        // Item has been recognized, so remove loaded event to stop the storyboard
                        // from starting again
                        fe.Loaded.unsubscribe(this.ItemLoaded);
                    };
                    /// <summary>
                    /// This is actually a MouseLeftButtonDown handler on an element within a list item
                    /// (see the ItemTemplate of the 'List').  Use it here to simulate a double click.
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    StatusBar.prototype.DoubleClickHandler = function (sender, e) {
                        //var now: DateTime = DateTime.Now;
                        //if (now.Subtract(this.m_lastTime).Ticks <= 300) {
                        var item = null;
                        var id = sender;
                        item = this.GetElement(id, this.m_statusList);
                        if (item != null) {
                            var content = (item.Details != null) ? "  " + item.Details : "  " + item.Message;
                            var db = new ViewPoint.Client.Toolkit.Controls.DialogBox(content, item.Type, Controls.DialogBoxButtons.Ok);
                            db.CenterOnScreen();
                            db.ShowModal();
                        }
                        //}
                        //this.m_lastTime = now;
                    };
                    StatusBar.prototype.InitializeComponent = function (angularObject) {
                        this.StatusWatermark = new TextBlock();
                        this.StatusWatermark.HtmlObject = angularObject.StatusWatermark;
                        this.m_statusList = angularObject.StatusBar_List;
                        this.AngularObject = angularObject;
                    };
                    StatusBar.Height = 15;
                    StatusBar.statusBar = null;
                    return StatusBar;
                }(UserControl));
                Controls.StatusBar = StatusBar;
            })(Controls = Toolkit.Controls || (Toolkit.Controls = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Utilities;
            (function (Utilities) {
                var VisualStateHelper = /** @class */ (function () {
                    function VisualStateHelper() {
                    }
                    /// <summary>
                    /// Tries to go to a new state and throws a friendly error message
                    /// </summary>
                    /// <param name="control">Control that is going to change the state.</param>
                    /// <param name="stateName">Name of the state.</param>
                    /// <param name="useTransitions">Use transitions or not.</param>
                    VisualStateHelper.GoToState = function (control, stateName, useTransitions) {
                        try {
                            VisualStateManager.GoToState(control, stateName, useTransitions);
                        }
                        catch (exc) {
                            throw new System.InvalidOperationException(System.String.Format(CultureInfo.CurrentCulture, "Cannot go to state {0} in {1}.\nPlease verify you have this state in the Style and all the storyboards reference existing elements in the template.", stateName, control.GetType().Name), exc);
                        }
                    };
                    return VisualStateHelper;
                }());
                Utilities.VisualStateHelper = VisualStateHelper;
            })(Utilities = Toolkit.Utilities || (Toolkit.Utilities = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Controls;
            (function (Controls) {
                var Context = /** @class */ (function () {
                    function Context() {
                        this.PreviousActiveWindows = new List();
                        this.WindowOrder = new List();
                        this.ModalWindow = new List();
                        this.ModalLayer = new Rectangle();
                        this.ActiveWindow = null;
                        this.PreviousActiveWindows = new List();
                        this.WindowOrder = new List();
                        this.ModalWindow = new List();
                        this.ModalLayer = new System.Windows.Shapes.Rectangle();
                        this.Popup = null;
                    }
                    return Context;
                }());
                Controls.Context = Context;
                /// <summary>
                /// Shows content in a window inside Silverlight.
                /// </summary>	
                var Window = /** @class */ (function (_super) {
                    __extends(Window, _super);
                    function Window() {
                        var _this = _super.call(this) || this;
                        // Flag used to disable firing of the IsActiveChanged event 
                        _this._throwIsActiveChanged = true;
                        // Flag used to disable firing of the IsMaximizedChanged event 
                        _this._throwIsMaximizedChanged = true;
                        // Flag used to disable firing of the IsMouseOverChanged event 
                        _this._throwIsMouseOverChanged = true;
                        /*AIS_TODO this.Closing = new CancelEventHandler();*/
                        _this.Closed = new EventHandler();
                        _this.Opened = new EventHandler();
                        _this.IsMouseOverChanged = new EventHandler();
                        _this.IsMaximizedChanged = new EventHandler();
                        _this.IsActiveChanged = new EventHandler();
                        _this.dragHelper = null;
                        _this._canvas = null;
                        _this._context = null;
                        _this._isClosing = null;
                        /*AIS_TODO this.previousPos = new System.Windows.Point();*/
                        _this.resizeDir = null;
                        _this.virtualHeight = null;
                        _this.virtualWidth = null;
                        _this.restore = null;
                        _this.minSize = null;
                        _this._hasClosed = null;
                        _this._elementDrag = null;
                        _this._elementRoot = null;
                        _this._elementClose = null;
                        _this._elementResize = null;
                        _this._elementContent = null;
                        _this._elementMaximize = null;
                        _this._throwIsActiveChanged = true;
                        _this._throwIsMaximizedChanged = true;
                        _this._throwIsMouseOverChanged = true;
                        _this.DefaultStyleKey = lang.typeOf();
                        /*AIS_TODO this.IsEnabledChanged.subscribe(function (s,a) {
                           this.ChangeVisualStateCommon(true);
                        });*/
                        // set custom default values
                        _this.SetCustomDefaultValues();
                        _this.Loaded.subscribe(_this.Window_Loaded, _this);
                        return _this;
                    }
                    Object.defineProperty(Window.prototype, "Left", {
                        //region Properties
                        //region Left
                        /// <summary>
                        /// Gets or sets the distance from the left side of the window to the left side of its container.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.LeftProperty);
                        },
                        //region Properties
                        //region Left
                        /// <summary>
                        /// Gets or sets the distance from the left side of the window to the left side of its container.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.LeftProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "Top", {
                        //region Top
                        /// <summary>
                        /// Gets or sets the distance from the top side of the window to the top side of its container.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.TopProperty);
                        },
                        //region Top
                        /// <summary>
                        /// Gets or sets the distance from the top side of the window to the top side of its container.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.TopProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "IsActive", {
                        //region IsActive
                        /// <summary>
                        /// Gets or sets whether the window is the active window.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.IsActiveProperty);
                        },
                        //region IsActive
                        /// <summary>
                        /// Gets or sets whether the window is the active window.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.IsActiveProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "IsMaximized", {
                        //region IsMaximized
                        /// <summary>
                        /// Gets or sets whether the window is maximized.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.IsMaximizedProperty);
                        },
                        //region IsMaximized
                        /// <summary>
                        /// Gets or sets whether the window is maximized.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.IsMaximizedProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "IsResizable", {
                        //region IsResizable
                        /// <summary>
                        /// Gets or sets whether the window can be resized and maximized.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.IsResizableProperty);
                        },
                        //region IsResizable
                        /// <summary>
                        /// Gets or sets whether the window can be resized and maximized.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.IsResizableProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "ModalBackground", {
                        //region ModalBackground
                        /// <summary>
                        /// Gets or sets the brushed used on the background when showing a modal window.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.ModalBackgroundProperty);
                        },
                        //region ModalBackground
                        /// <summary>
                        /// Gets or sets the brushed used on the background when showing a modal window.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.ModalBackgroundProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "ShowMaximizeButton", {
                        //region ShowMaximizeButton
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.ShowMaximizeButtonProperty);
                        },
                        //region ShowMaximizeButton
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.ShowMaximizeButtonProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "ShowCloseButton", {
                        //region ShowCloseButton
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.ShowCloseButtonProperty);
                        },
                        //region ShowCloseButton
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.ShowCloseButtonProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "DialogResult", {
                        //region DialogResult
                        /// <summary>
                        /// Gets or sets the dialog result for the window.
                        /// </summary>
                        /// <remarks>
                        /// Setting this property to a value other than "None" automatically closes the window. Clicking the "Close" button on the window caption bar sets DialogResult to <see cref="MessageBoxResult.Cancel"/> and then closes the window.
                        /// </remarks>
                        get: function () {
                            /*AIS_TODO return <MessageBoxResult>this.GetValue(Window.DialogResultProperty);*/
                            throw ("notImplemented");
                        },
                        //region DialogResult
                        /// <summary>
                        /// Gets or sets the dialog result for the window.
                        /// </summary>
                        /// <remarks>
                        /// Setting this property to a value other than "None" automatically closes the window. Clicking the "Close" button on the window caption bar sets DialogResult to <see cref="MessageBoxResult.Cancel"/> and then closes the window.
                        /// </remarks>
                        set: function (value /*AIS_TODO : MessageBoxResult*/) {
                            this.SetValue(Window.DialogResultProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "IsMouseOver", {
                        //region IsMouseOver
                        /// <summary>
                        /// Returns true if the mouse is over the control.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.IsMouseOverProperty);
                        },
                        //region IsMouseOver
                        /// <summary>
                        /// Returns true if the mouse is over the control.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.IsMouseOverProperty, value);
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "Title", {
                        //region Title
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        get: function () {
                            return this.GetValue(Window.TitleProperty);
                        },
                        //region Title
                        /// <summary>
                        /// Gets or sets whether the maximize button of this window is shown.
                        /// </summary>
                        set: function (value) {
                            this.SetValue(Window.TitleProperty, value);
                            //var _DialogBox = lang.asTypeT(this, ViewPoint.Client.Toolkit.Controls.DialogBox);
                            //if (_DialogBox !== null){
                            //   var htmlElement = $("#" + _DialogBox._HTMLDialogBox.attr("id"));            
                            //   console.log(htmlElement.find("#Title"));
                            //}else{
                            //document.getElementById('Title').textContent = value;
                            //}
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "KeyDownFunction", {
                        get: function () {
                            return this._keyDownFunction;
                        },
                        set: function (value) {
                            this._keyDownFunction = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(Window.prototype, "Canvas", {
                        /// <summary>
                        /// Gets or sets the <see cref="Canvas"/> used to display the window.
                        /// </summary>
                        get: function () {
                            return this._canvas;
                        },
                        /// <summary>
                        /// Gets or sets the <see cref="Canvas"/> used to display the window.
                        /// </summary>
                        set: function (value) {
                            if (value == null) {
                                throw new System.ArgumentNullException("value");
                            }
                            if (this._hasClosed || (this._canvas != null && this._canvas.Children.Contains(this))) {
                                throw new System.InvalidOperationException("Cannot change Canvas when window has opened");
                            }
                            if (this._canvas != null) {
                                this._canvas.SizeChanged.unsubscribe(this.CanvasSizeChanged);
                                this._context.WindowOrder.Remove(this);
                                this.fixWindowOrder();
                            }
                            this._canvas = value;
                            this._canvas.SizeChanged.subscribe(this.CanvasSizeChanged, this);
                            if (!(function () {
                                var _tmp = Window._contexts.TryGetValue(this._canvas, this._context);
                                this._context = _tmp.refs[0];
                                return _tmp.result;
                            }).apply(this)) {
                                Window._contexts.Add(this._canvas, this._context = new ViewPoint.Client.Toolkit.Controls.Context());
                            }
                            this._context.WindowOrder.Add(this);
                            this.CanvasSizeChanged(this._canvas, null);
                            this.fixWindowOrder();
                        },
                        enumerable: true,
                        configurable: true
                    });
                    //region VisualStates Groups
                    Window.prototype.ChangeVisualStateActive = function (useTransitions) {
                        if (this.IsActive == false) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Inactive", useTransitions);*/
                        }
                        if (this.IsActive == true) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Active", useTransitions);*/
                        }
                    };
                    Window.prototype.ChangeVisualStateMaximized = function (useTransitions) {
                        if (this.IsMaximized == true) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Maximized", useTransitions);*/
                        }
                        if (this.IsMaximized == false) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Normal", useTransitions);*/
                        }
                    };
                    Window.prototype.ChangeVisualStateOpen = function (useTransitions) {
                        if (this._isClosing) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Closed", useTransitions);*/
                        }
                        else {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Open", useTransitions);*/
                        }
                    };
                    //region property changes
                    Window.prototype.OnLeftChanged = function (oldValue) {
                        // Rounding prevents blurring of some objects
                        this.SetValue(Canvas.LeftProperty, Math.round(this.Left));
                    };
                    Window.prototype.OnTopChanged = function (oldValue) {
                        // Rounding prevents blurring of some objects
                        this.SetValue(Canvas.TopProperty, Math.round(this.Top));
                    };
                    Window.prototype.OnIsActiveChanged = function (oldValue) {
                        if (this._hasClosed) {
                            return;
                        }
                        if (this._context.ActiveWindow != this && this._context.ActiveWindow != null && this._context.PreviousActiveWindows.LastOrDefault() != this._context.ActiveWindow) {
                            this._context.PreviousActiveWindows.Add(this._context.ActiveWindow);
                            while (this._context.PreviousActiveWindows.Count > Window.maxWindowHistory) {
                                this._context.PreviousActiveWindows.RemoveAt(0);
                            }
                        }
                        if (this.IsActive) {
                            if (this._context.ActiveWindow != this && this._context.ActiveWindow != null)
                                this._context.ActiveWindow.IsActive = false;
                            this._context.ActiveWindow = this;
                        }
                        else if (this._context.ActiveWindow == this)
                            this._context.ActiveWindow = null;
                    };
                    Window.prototype.OnIsMaximizedChanged = function (oldValue) {
                        if (this.IsMaximized) {
                            this.restore = new System.Windows.Rect(this.Left, this.Top, this.Width, this.Height);
                            this.Left = 0;
                            this.Top = 0;
                            this.Width = this._canvas.ActualWidth;
                            this.Height = this._canvas.ActualHeight;
                        }
                        else {
                            this.Left = this.restore.Left;
                            this.Top = this.restore.Top;
                            this.Width = this.restore.Width;
                            this.Height = this.restore.Height;
                        }
                        if (this._elementResize != null)
                            this._elementResize.IsHitTestVisible = !this.IsMaximized;
                    };
                    Window.prototype.OnIsResizableChanged = function (oldValue) {
                        if (this._elementResize != null) {
                            this._elementResize.IsHitTestVisible = this.IsResizable;
                            if (!this.IsResizable) {
                                // if IsResizable is turned off while resizing, this prevents it from continuing resizing when it's turned on again
                                this.ResizeMouseUp();
                            }
                        }
                        this.OnShowMaximizeButtonChanged(this.ShowMaximizeButton);
                    };
                    Window.prototype.OnShowMaximizeButtonChanged = function (oldValue) {
                        if (this._elementMaximize != null)
                            this._elementMaximize.Visibility = this.IsResizable && this.ShowMaximizeButton ? 0 /* Visible */ : 1 /* Collapsed */;
                    };
                    Window.prototype.OnShowCloseButtonChanged = function (oldValue) {
                        if (this._elementClose != null)
                            this._elementClose.Visibility = this.ShowCloseButton ? 0 /* Visible */ : 1 /* Collapsed */;
                    };
                    Window.prototype.OnDialogResultChanged = function (oldValue /*AIS_TODO : MessageBoxResult*/) {
                        /*AIS_TODO if (this.DialogResult != MessageBoxResult.None) {
                           this.Close();
                        }*/
                        throw ("notImplemented");
                    };
                    //region initialization
                    Window.prototype.SetCustomDefaultValues = function () {
                        this.InitializeDefaultCanvas();
                        this.IsEnabled = true;
                        this.MouseLeftButtonDown.subscribe(function (s, e) {
                            this.BringToFront();
                            this.IsActive = true;
                        }, this);
                        this.LostFocus.subscribe(function (s, e) {
                            return this.IsActive = false;
                        }, this);
                        this.Canvas = Window._defaultCanvas;
                    };
                    Window.prototype.OnGotFocus = function (e) {
                        this.BringToFront();
                        this.IsActive = true;
                    };
                    Window.prototype.InitializeDefaultCanvas = function () {
                        if (Window._defaultCanvas == null) {
                            Window._defaultCanvas = new System.Windows.Controls.Canvas();
                            var context = new ViewPoint.Client.Toolkit.Controls.Context();
                            Window._contexts.Add(Window._defaultCanvas, context);
                            Window._defaultCanvas.SetValue(Canvas.ZIndexProperty, Window.ZIndex);
                            context.Popup = (function () {
                                var _tmp = new System.Windows.Controls.Primitives.Popup;
                                _tmp.Child = Window._defaultCanvas;
                                _tmp.IsOpen = true;
                                return _tmp;
                            })();
                            Application.Current.Host.Content.Resized.subscribe(this.Content_Resized, this);
                            this.AttachApplicationRoot();
                        }
                        else {
                            if (Window._contexts.getItem(Window._defaultCanvas).Popup.IsOpen == false) {
                                Window._contexts.getItem(Window._defaultCanvas).Popup.IsOpen = true;
                            }
                        }
                    };
                    Window.prototype.OnAfterApplyTemplate = function () {
                        this.restore = new System.Windows.Rect(this.Left, this.Top, this.Width, this.Height);
                        this.OnIsMaximizedChanged(false);
                        this.OnIsResizableChanged(false);
                        this.OnShowMaximizeButtonChanged(false);
                        this.OnShowCloseButtonChanged(false);
                        this.AttachApplicationRoot();
                    };
                    Window.prototype.AttachApplicationRoot = function () {
                        Window._defaultCanvas.Width = Application.Current.Host.Content.ActualWidth;
                        Window._defaultCanvas.Height = Application.Current.Host.Content.ActualHeight;
                    };
                    Window.prototype.Content_Resized = function (sender, e) {
                        Window._defaultCanvas.Width = Application.Current.Host.Content.ActualWidth;
                        Window._defaultCanvas.Height = Application.Current.Host.Content.ActualHeight;
                    };
                    Window.prototype.InitializeDragPart = function () {
                        this.dragHelper /*AIS_TODO = new ViewPoint.Client.Toolkit.Utilities.MouseHelper(this._elementDrag)*/;
                        this.dragHelper.MouseDoubleClick.subscribe(function (s, e) {
                            if (this.IsResizable)
                                this.IsMaximized = !this.IsMaximized;
                        }, this);
                        this.dragHelper.MouseDragMove.subscribe(function (s, e) {
                            if (!this.IsMaximized) {
                                var size = new System.Windows.Size(this._canvas.ActualWidth, this._canvas.ActualHeight);
                                var currentPoint = e.GetPosition(this._canvas);
                                var previousPoint = e.PreviousPosition;
                                this.Left += Math.min(size.Width, Math.max(currentPoint.X, 0)) - Math.min(size.Width, Math.max(previousPoint.X, 0));
                                this.Top += Math.min(size.Height, Math.max(currentPoint.Y, 0)) - Math.min(size.Height, Math.max(previousPoint.Y, 0));
                                this.InvalidateMeasure();
                            }
                        }, this);
                    };
                    Window.prototype.InitializeClosePart = function () {
                        /*AIS_TODO this._elementClose.Click.subscribe(function (s,e) {
                           return this.DialogResult = MessageBoxResult.Cancel;
                        });*/
                        throw ("notImplemented");
                    };
                    Window.prototype.InitializeResizePart = function () {
                        this._elementResize.MouseLeftButtonDown.subscribe(function (s, e) {
                            return this.ResizeMouseDown(e.GetPosition(this._elementResize));
                        }, this);
                        this._elementResize.MouseMove.subscribe(function (s, e) {
                            return this.ResizeMouseMove(e.GetPosition(this._elementResize));
                        }, this);
                        // hook from mouse enter so that the correct cursor is shown when the mouse just entered but hasn't moved yet
                        this._elementResize.MouseEnter.subscribe(function (s, e) {
                            return this.ResizeMouseMove(e.GetPosition(this._elementResize));
                        }, this);
                        this._elementResize.MouseLeftButtonUp.subscribe(function (s, e) {
                            return this.ResizeMouseUp();
                        }, this);
                    };
                    Window.prototype.InitializeMaximizePart = function () {
                        /*AIS_TODO this._elementMaximize.Click.subscribe(function (s,e) {
                           return this.IsMaximized = !this.IsMaximized;
                        });*/
                        throw ("notImplemented");
                    };
                    //region resizing
                    Window.prototype.ResizeMouseDown = function (pos) {
                        this._elementResize.CaptureMouse();
                        this.previousPos = pos;
                        this.resizeDir = this.ResizeDir(pos);
                        this.Width = this.virtualWidth = this.ActualWidth;
                        this.Height = this.virtualHeight = this.ActualHeight;
                    };
                    Window.prototype.ResizeMouseMove = function (pos) {
                        if (this.resizeDir /*AIS_TODO != new System.Windows.Point(0,0)*/) {
                            var resize = new System.Windows.Point(this.resizeDir.X * (pos.X - this.previousPos.X), this.resizeDir.Y * (pos.Y - this.previousPos.Y));
                            this.virtualWidth += resize.X;
                            this.virtualHeight += resize.Y;
                            var actualResize = new System.Windows.Point(this.BoundWidth(this.virtualWidth) - this.Width, this.BoundHeight(this.virtualHeight) - this.Height);
                            this.Width += actualResize.X;
                            this.Height += actualResize.Y;
                            if (this.resizeDir.X < 0)
                                this.Left -= actualResize.X;
                            if (this.resizeDir.Y < 0)
                                this.Top -= actualResize.Y;
                            this.previousPos = new System.Windows.Point(pos.X + (this.resizeDir.X < 0 ? actualResize.X : 0), pos.Y + (this.resizeDir.Y < 0 ? actualResize.Y : 0));
                        }
                        else {
                            var dir = this.ResizeDir(pos);
                            if (dir.X != 0 && dir.Y != 0)
                                this._elementResize.Cursor = Cursors.Hand;
                            else if (dir.X != 0)
                                this._elementResize.Cursor = Cursors.SizeWE;
                            else if (dir.Y != 0)
                                this._elementResize.Cursor = Cursors.SizeNS;
                            else
                                this._elementResize.Cursor = Cursors.Arrow;
                        }
                    };
                    Window.prototype.ResizeMouseUp = function () {
                        this._elementResize.ReleaseMouseCapture();
                        /*AIS_TODO this.resizeDir = new System.Windows.Point();*/
                    };
                    // returns the direction of resize corresponding to a mouse position inside the window
                    // the return type is a Point used as a vector
                    Window.prototype.ResizeDir = function (pos) {
                        var dir /*AIS_TODO = new System.Windows.Point()*/;
                        if (pos.X < this._elementResize.BorderThickness.Left)
                            dir.X = -1;
                        else if (pos.X >= this._elementResize.ActualWidth - this._elementResize.BorderThickness.Right)
                            dir.X = 1;
                        if (pos.Y < this._elementResize.BorderThickness.Top)
                            dir.Y = -1;
                        else if (pos.Y >= this._elementResize.ActualHeight - this._elementResize.BorderThickness.Bottom)
                            dir.Y = 1;
                        return dir;
                    };
                    // returns the width bounded to the minimum and maximum width of the window
                    Window.prototype.BoundWidth = function (width) {
                        this.minSize.Width = Math.max(this.minSize.Width, this.ActualWidth - this._elementContent.ActualWidth);
                        var min = Math.max(this.MinWidth, Math.max(this._elementRoot.MinWidth, this.minSize.Width));
                        var max = Math.min(this.MaxWidth, this._elementRoot.MaxWidth);
                        return Math.min(Math.max(width, min), max);
                    };
                    // returns the height bounded to the minimum and maximum width of the height
                    Window.prototype.BoundHeight = function (height) {
                        this.minSize.Height = Math.max(this.minSize.Height, this.ActualHeight - this._elementContent.ActualHeight);
                        var min = Math.max(this.MinHeight, Math.max(this._elementRoot.MinHeight, this.minSize.Height));
                        var max = Math.min(this.MaxHeight, this._elementRoot.MaxHeight);
                        return Math.min(Math.max(height, min), max);
                    };
                    //region VisualStates Groups
                    Window.prototype.ChangeVisualStateCommon = function (useTransitions) {
                        if (this.IsEnabled == true && this.IsMouseOver == false) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Normal", useTransitions);*/
                        }
                        if (this.IsEnabled == false) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "Disabled", useTransitions);*/
                        }
                        if (this.IsEnabled == true && this.IsMouseOver == true) {
                            /*AIS_TODO VisualStateHelper.GoToState(this, "MouseOver", useTransitions);*/
                        }
                    };
                    Window.prototype.Window_Loaded = function (sender, e) {
                        this.ApplyTemplate();
                    };
                    /// <summary>
                    /// Puts the window in front of all windows.
                    /// </summary>
                    Window.prototype.BringToFront = function () {
                        if (!this._hasClosed) {
                            this._context.WindowOrder.Remove(this);
                            this._context.WindowOrder.Add(this);
                            this.fixWindowOrder();
                        }
                    };
                    /// <summary>
                    /// Positions the window so that the specified point in the window matches the specified point of a FrameworkElement.
                    /// </summary>
                    /// <remarks>
                    /// If the window is not yet loaded the positioning is delayed until it's loaded.
                    /// </remarks>
                    /// <param name="windowAnchor">An <see cref="T:C1.Silverlight.Anchor" /> value specifying the point in the window.</param>
                    /// <param name="reference">The <see cref="T:System.Windows.FrameworkElement" /> to use as reference.</param>
                    /// <param name="referenceAnchor">An <see cref="T:C1.Silverlight.Anchor" /> value specifying the point in the FrameworkElement.</param>
                    Window.prototype.Position = function (windowAnchor /*AIS_TODO : Anchor*/, reference, referenceAnchor /*AIS_TODO : Anchor*/) {
                        this.OnLayout(function () {
                            var point /*AIS_TODO = PopupUtil.TestPosition(this, windowAnchor, reference, referenceAnchor, 0, 0)*/;
                            try {
                                point = Application.Current.RootVisual.TransformToVisual(this._canvas).Transform(point);
                            }
                            catch (_) {
                            }
                            this.Left = point.X;
                            this.Top = point.Y;
                        });
                    };
                    /// <summary>
                    /// Centers the window in its container.
                    /// </summary>
                    /// <remarks>
                    /// If the window is not yet loaded the positioning is delayed until it's loaded.
                    /// </remarks>
                    Window.prototype.CenterOnScreen = function () {
                        this.OnLayout(function () {
                            this.Left = (this._canvas.ActualWidth - this.ActualWidth) / 2;
                            this.Top = (this._canvas.ActualHeight - this.ActualHeight) / 2;
                        });
                    };
                    /// <summary>
                    /// Opens the window.
                    /// </summary>
                    /// <remarks>
                    /// Calling Show makes the window visible, active and in front of other windows.
                    /// A window cannot be reopened after it has been closed. It's possible to hide the window without closing it using <see cref="M:C1.Silverlight.Window.Hide" /> or the <see cref="T:System.Windows.Visibility" /> property.
                    /// </remarks>
                    Window.prototype.Show = function () {
                        this.VerifyCanShow();
                        if (!this._canvas.Children.Contains(this)) {
                            this._canvas.Children.Add(this);
                        }
                        this.Visibility = 0 /* Visible */;
                        this.IsActive = true;
                        this.BringToFront();
                        this.ChangeVisualStateOpen(true);
                    };
                    Window.prototype.OnResizeFixPosition = function () {
                    };
                    Window.prototype.Focus = function () {
                        _super.prototype.Focus.call(this);
                        try {
                            window.removeEventListener("keydown", this.getKeyDownFunction(this));
                        }
                        catch (_) { }
                        window.addEventListener("keydown", this.getKeyDownFunction(this));
                        return true;
                    };
                    Window.prototype.OnLostFocus = function (e) {
                        _super.prototype.OnLostFocus.call(this);
                        try {
                            window.removeEventListener("keydown", this.getKeyDownFunction(this));
                        }
                        catch (_) { }
                    };
                    Window.prototype.getKeyDownFunction = function (intance) {
                        if (!this.KeyDownFunction) {
                            var that = intance;
                            this.KeyDownFunction = function (ev) {
                                if (ev.keyCode == KeyInput.Enter) {
                                    var confirmationDialog = $('#DialogBoxRoot' + Controls.DialogBox.HTMLIndex);
                                    if (confirmationDialog.length || confirmationDialog.length > 0) {
                                        confirmationDialog.find("#btnYes").click();
                                    }
                                }
                            };
                        }
                        return this.KeyDownFunction;
                    };
                    /// <summary>
                    /// Opens the window as modal.
                    /// </summary>
                    /// <remarks>
                    /// Opens the window over a grayed out layer preventing the user from interacting with anything else until the window is closed.
                    /// </remarks>
                    Window.prototype.ShowModal = function (Title, isAboutDialog) {
                        this.VerifyCanShow();
                        if (this._canvas.Children.Contains(this) && this.Visibility == 0 /* Visible */) {
                            /*AIS_TODO throw new System.InvalidOperationException("ShowModal can be called only on hidden windows.");*/
                        }
                        if (!this._canvas.Children.Contains(this)) {
                            this._canvas.Children.Add(this);
                        }
                        this._context.ModalWindow.Remove(this);
                        this._context.ModalWindow.Add(this);
                        /*AIS_TODO this.TabNavigation = KeyboardNavigationMode.Cycle;*/
                        this.Visibility = 0 /* Visible */;
                        this.Focus();
                        Control.lastFocus = null;
                        this.fixWindowOrder();
                        /*AIS_TODO this.IsActive = true;*/
                        this.ChangeVisualStateOpen(true);
                        var WindowObject = window;
                        if (this.DialogName) {
                            var dlg = $("#" + this.DialogName);
                            var that = this;
                            dlg.modal({
                                backdrop: 'static',
                                keyboard: false,
                                show: true
                            });
                            var OnResizeFixPosition = function () {
                                var window = document.getElementById("_displayRoot");
                                if (window && dlg) {
                                    if (window.clientHeight == 0 && window.clientWidth == 0)
                                        window = document.getElementById("DisplayArea");
                                    var winheight = (Convert.ToFloat(window.clientHeight) / 2);
                                    var winwidth = (Convert.ToFloat(window.clientWidth) / 2);
                                    var id = dlg.attr("id");
                                    var height = $($('#' + id)[0]).find('#DivDialogBox').height() / 2;
                                    var width = $($('#' + id)[0]).find('#DivDialogBox').width() / 2;
                                    var X = (winwidth - width);
                                    var Y = (winheight - height);
                                    dlg.find("#dialogposition").attr("style", "top:" + (Y < 0 ? 20 : Y) + "px; left:" + (X < 0 ? 20 : X) + "px; margin:0px; display:inline-block; width:auto;");
                                    if (Title) {
                                        dlg.find("#Title").parent().children('span').get(0).innerHTML = Title;
                                        if (Title == "About FactoryTalk ViewPoint") {
                                            dlg.find("#DialogContent").attr("style", "text-align:left;padding-left:0px;");
                                            dlg.find("#DialogContent").find("br").remove();
                                        }
                                        else {
                                            dlg.find("#DialogContent").attr("style", "text-align:left;");
                                        }
                                    }
                                    else {
                                        if (dlg.find("#DialogContent")[0].getElementsByTagName("img").length > 0) {
                                            dlg.find("#DialogContent").attr("style", "text-align:left;padding-left:0px;");
                                        }
                                        else {
                                            dlg.find("#DialogContent").attr("style", "text-align:left;padding-left:20px;");
                                        }
                                    }
                                    dlg.find("#DialogContent *").attr("style", "max-width: " + ((winwidth * 2) - 80) + "px; white-space: pre-line; text-align: justify;");
                                    dlg.find(".header-dialog-box").attr("style", "text-align:left;");
                                    dlg.attr("style", "overflow: hidden; display: block; z-index: 1050;");
                                }
                                else if (dlg) {
                                    dlg.find("#dialogposition").attr("style", "display: block;");
                                    var left = ($('html').width() - $("#DivDialogBox")[0].clientWidth) / 2;
                                    var top = ($('html').height() - $("#DivDialogBox")[0].clientHeight) / 2;
                                    dlg.find("#dialogposition").attr("style", "top:" + top + "px;left:" + left + "px;position: absolute;display: block;");
                                }
                            };
                            dlg.on('hidden.bs.modal', function () {
                                WindowObject.removeEventListener('resize', OnResizeFixPosition);
                                $(this).parent().remove();
                            });
                            dlg.on('shown.bs.modal', function () {
                                WindowObject.addEventListener('resize', OnResizeFixPosition, false);
                                OnResizeFixPosition();
                            });
                            if (isAboutDialog)
                                dlg.find('.modal-dialog').draggable();
                            else
                                dlg.draggable();
                            var winwidth = (window.innerWidth) - 40;
                            $('.content-dialog-box').css("max-width", winwidth);
                            $('#DialogContent').css("width", "100%");
                            $('#DialogContent').css("text-align", "left");
                            $('#' + this.DialogName).css("overflow", "hidden");
                        }
                    };
                    Window.prototype.ShowMaximized = function (restorerect) {
                        this.OnLayout(function () {
                            this.IsMaximized = true;
                            this.Left = 0;
                            this.Top = 0;
                            this.Width = this._canvas.ActualWidth;
                            this.Height = this._canvas.ActualHeight;
                        });
                        this.restore = restorerect;
                        if (this._elementResize != null)
                            this._elementResize.IsHitTestVisible = !this.IsMaximized;
                    };
                    /// <summary>
                    /// Hides the window without closing it.
                    /// </summary>
                    Window.prototype.Hide = function () {
                        this.Visibility = 1 /* Collapsed */;
                        this.fixWindowOrder();
                    };
                    /// <summary>
                    /// Closes the window.
                    /// </summary>
                    /// <remarks>
                    /// A window cannot be reopened after it has been closed.
                    /// </remarks>
                    Window.prototype.Close = function () {
                        if (this._hasClosed) {
                            return;
                        }
                        this._isClosing = true;
                        this.ChangeVisualStateOpen(true);
                    };
                    /// <summary>
                    /// Set the displayed window to active once the WindowState open is complete
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    Window.prototype.OnOpenComplete = function (sender, e) {
                        this.IsActive = true;
                        if (this.Opened != null) {
                            this.Opened.raise(this, null);
                        }
                    };
                    Object.defineProperty(Window.prototype, "DialogName", {
                        get: function () {
                            return this._DialogName;
                        },
                        set: function (value) {
                            this._DialogName = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    /// <summary>
                    /// Once the WindowState close is complete, close the window completely
                    /// </summary>
                    /// <param name="sender"></param>
                    /// <param name="e"></param>
                    Window.prototype.OnCloseComplete = function (sender, e) {
                        if (this.Closing != null) {
                            var args /*AIS_TODO = new CancelEventArgs()*/;
                            this.Closing(this, args);
                            if (args.Cancel) {
                                /*AIS_TODO this.DialogResult = MessageBoxResult.None;*/
                                return;
                            }
                        }
                        this._context.ModalWindow.Remove(this);
                        if (this._context.ActiveWindow == this) {
                            this._context.ActiveWindow = null;
                        }
                        while (this._context.PreviousActiveWindows.Remove(this))
                            ;
                        if (this._context.PreviousActiveWindows.Count > 0) {
                            this._context.PreviousActiveWindows.Last().IsActive = true;
                        }
                        this._context.WindowOrder.Remove(this);
                        this.fixWindowOrder();
                        this._canvas.SizeChanged.unsubscribe(this.CanvasSizeChanged);
                        this._canvas.Children.Remove(this);
                        this._hasClosed = true;
                        if (this.Closed != null)
                            this.Closed.raise(this, null);
                        // Close the popup if all windows have been removed
                        if (this._context.WindowOrder.Count == 0) {
                            this._context.Popup.IsOpen = false;
                        }
                    };
                    //region miscellaneous
                    Window.prototype.VerifyCanShow = function () {
                        if (this._hasClosed)
                            /*AIS_TODO throw new System.InvalidOperationException("Cannot call Show or ShowModal after window has closed.");*/
                            throw ("NotImplemented");
                    };
                    Window.prototype.fixWindowOrder = function () {
                        /*AIS_TODO
                        var z : number = 0;
                        for (var _index in this._context.WindowOrder.itemArray) {
                           var w: any = this._context.WindowOrder.itemArray[_index];
                           w.SetValue(this.Canvas.ZIndexProperty, z++);
                        }
                        this._canvas.Children.Remove(this._context.ModalLayer);
                        var modalWindows : any = this._context.ModalWindow.Where(function (w) {
                           return w.Visibility == Visibility.Visible;
                        }).ToList();
                        if (modalWindows.Count > 0) {
                           for (var _index in modalWindows) {
                              var w : any = modalWindows[_index];
                              w.SetValue(this.Canvas.ZIndexProperty, z++);
                           }
                           modalWindows.Last().SetValue(this.Canvas.ZIndexProperty, z + 1);
                           this._context.ModalLayer.Fill = modalWindows.Last().ModalBackground;
                           this._context.ModalLayer.SetValue(this.Canvas.ZIndexProperty, z);
                           this._canvas.Children.Add(this._context.ModalLayer);
                        }*/
                    };
                    Window.prototype.OnLayout = function (a /*AIS_TODO : Action*/) {
                        var handler /*AIS_TODO : EventHandler*/ = function (s, e) {
                        };
                        handler = function (s, e) {
                            // See if object fits on screen - only check once or recursion happens
                            if (Double.IsNaN(this.Width) && this._canvas.ActualWidth < this.ActualWidth) {
                                this.Width = this._canvas.ActualWidth - 40;
                            }
                            else {
                                a();
                                this.LayoutUpdated.unsubscribe(handler);
                            }
                        };
                        this.LayoutUpdated.subscribe(handler, this);
                        /*AIS_TODO this.InvalidateMeasure();*/
                    };
                    Window.prototype.CanvasSizeChanged = function (sender, e /*AIS_TODO : SizeChangedEventArgs*/) {
                        if (this.IsMaximized) {
                            this.Width = this.Canvas.ActualWidth;
                            this.Height = this.Canvas.ActualHeight;
                        }
                        else {
                            if (this.Left + this.ActualWidth > this.Canvas.ActualWidth) {
                                this.Left = this.Canvas.ActualWidth - this.ActualWidth;
                            }
                            if (this.Top + this.ActualHeight > this.Canvas.ActualHeight) {
                                this.Top = this.Canvas.ActualHeight - this.ActualHeight;
                            }
                            if (this.Left < 0) {
                                this.Left = 0;
                            }
                            if (this.Top < 0) {
                                this.Top = 0;
                            }
                        }
                        this._context.ModalLayer.Width = this.Canvas.ActualWidth;
                        this._context.ModalLayer.Height = this.Canvas.ActualHeight;
                        this._canvas.Clip = (function () {
                            var _tmp = new System.Windows.Media.RectangleGeometry;
                            _tmp.Rect = new System.Windows.Rect(0, 0, this._canvas.ActualWidth, this._canvas.ActualHeight);
                            return _tmp;
                        }).apply(this);
                        this.fixWindowOrder();
                    };
                    Window.prototype.OnApplyTemplate = function () {
                        var errors = "";
                        _super.prototype.OnApplyTemplate.call(this);
                        // Get the elements 
                        // retrieve Drag from the template
                        this._elementDrag = (function () {
                            var _tmp = this.GetTemplateChild(Window.DragElementName, false, errors);
                            errors = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        if (this._elementDrag != null)
                            this.InitializeDragPart();
                        // retrieve Root from the template
                        this._elementRoot = (function () {
                            var _tmp = this.GetTemplateChild(Window.RootElementName, true, errors);
                            errors = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        // retrieve Close from the template
                        this._elementClose = (function () {
                            var _tmp = this.GetTemplateChild(Window.CloseElementName, false, errors);
                            errors = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        if (this._elementClose != null)
                            this.InitializeClosePart();
                        // retrieve Resize from the template
                        this._elementResize = (function () {
                            var _tmp = this.GetTemplateChild(Window.ResizeElementName, false, errors);
                            errors = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        if (this._elementResize != null)
                            this.InitializeResizePart();
                        // retrieve Content from the template
                        this._elementContent = (function () {
                            var _tmp = this.GetTemplateChild(Window.ContentElementName, true, errors);
                            errors = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        // retrieve Maximize from the template
                        this._elementMaximize = (function () {
                            var _tmp = this.GetTemplateChild(Window.MaximizeElementName, false, errors);
                            errors = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        if (this._elementMaximize != null)
                            this.InitializeMaximizePart();
                        if (!System.String.IsNullOrEmpty(errors)) {
                            // Don´t throw exception if open from Blend
                            if (!System.ComponentModel.DesignerProperties.GetIsInDesignMode(this)) {
                                /*AIS_TODO throw new System.InvalidOperationException(System.String.Format(CultureInfo.InvariantCulture, "Template cannot be applied to {0}.\nDetails: {1}", (<any>this).GetType().Name, errors));*/
                                throw ("notImplemented");
                            }
                        }
                        else {
                            this.ChangeVisualStateActive(true);
                            this.ChangeVisualStateMaximized(true);
                            this.OnAfterApplyTemplate();
                            this.ChangeVisualStateOpen(true);
                            var sb /*AIS_TODO : Storyboard = Utilities.Utilities.GetStoryBoard(this._elementRoot, "WindowStates", "Closed")*/;
                            if (sb != null)
                                sb.Completed.subscribe(this.OnCloseComplete, this);
                            // for open animation
                            /*AIS_TODO sb = Utilities.Utilities.GetStoryBoard(this._elementRoot, "WindowStates", "Open");*/
                            if (sb != null)
                                sb.Completed.subscribe(this.OnOpenComplete, this);
                        }
                    };
                    Window.prototype.GetTemplateChild = function () {
                        var params = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            params[_i] = arguments[_i];
                        }
                        switch (arguments.length) {
                            case 1:
                                return this.GetTemplateChild_1(arguments[0]);
                            case 3:
                                return this.GetTemplateChild_2(arguments[0], arguments[1], arguments[2]);
                        }
                    };
                    //region Private /* AIS_TODO REVIEW GetTemplateChild_2<T> BEHAIVOR */
                    Window.prototype.GetTemplateChild_1 = function (childName) {
                        throw ("notImplemented");
                    };
                    Window.prototype.GetTemplateChild_2 = function (childName, required, errors) {
                        var child = this.GetTemplateChild(childName);
                        (function () {
                            var _tmp /*AIS_TODO = Utilities.Utilities.VerifyTemplateChild(lang.typeOf<T>(), "template part", childName, child, required, errors)*/;
                            errors = _tmp.refs[0];
                            return _tmp.result;
                        }).apply(this);
                        return (lang.asType(child));
                    };
                    Window.OnLeftPropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue = e.OldValue;
                        var newValue = e.NewValue;
                        // Call the hook method if is required
                        sender.OnLeftChanged(oldValue);
                    };
                    Window.OnTopPropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue = e.OldValue;
                        var newValue = e.NewValue;
                        // Call the hook method if is required
                        sender.OnTopChanged(oldValue);
                    };
                    Window.OnIsActivePropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue = e.OldValue;
                        var newValue = e.NewValue;
                        // Call the hook method if is required
                        sender.OnIsActiveChanged(oldValue);
                        // Should notify when has changed...
                        if ((sender.IsActiveChanged != null) && (sender._throwIsActiveChanged)) {
                            sender.IsActiveChanged(sender, (function () {
                                var _tmp /*AIS_TODO = new PropertyChangedEventArgs<boolean>();
                                _tmp.OldValue = <boolean>e.OldValue;
                                _tmp.NewValue = <boolean>e.NewValue;
                                return _tmp*/;
                            })());
                        }
                        sender.ChangeVisualStateActive(true);
                    };
                    Window.OnIsMaximizedPropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue = e.OldValue;
                        var newValue = e.NewValue;
                        // Call the hook method if is required
                        sender.OnIsMaximizedChanged(oldValue);
                        // Should notify when has changed...
                        if ((sender.IsMaximizedChanged != null) && (sender._throwIsMaximizedChanged)) {
                            sender.IsMaximizedChanged(sender, (function () {
                                var _tmp /*AIS_TODO = new PropertyChangedEventArgs<boolean>();
                                _tmp.OldValue = <boolean>e.OldValue;
                                _tmp.NewValue = <boolean>e.NewValue;
                                return _tmp*/;
                            })());
                        }
                        sender.ChangeVisualStateMaximized(true);
                    };
                    Window.OnIsResizablePropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue = e.OldValue;
                        var newValue = e.NewValue;
                        // Call the hook method if is required
                        sender.OnIsResizableChanged(oldValue);
                    };
                    Window.OnShowMaximizeButtonPropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue = e.OldValue;
                        var newValue = e.NewValue;
                        // Call the hook method if is required
                        sender.OnShowMaximizeButtonChanged(oldValue);
                    };
                    Window.OnShowCloseButtonPropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue = e.OldValue;
                        var newValue = e.NewValue;
                        // Call the hook method if is required
                        sender.OnShowCloseButtonChanged(oldValue);
                    };
                    Window.OnDialogResultPropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        var oldValue /*AIS_TODO : MessageBoxResult = <MessageBoxResult>e.OldValue*/;
                        var newValue /*AIS_TODO : MessageBoxResult = <MessageBoxResult>e.NewValue*/;
                        // Call the hook method if is required
                        sender.OnDialogResultChanged(oldValue);
                    };
                    Window.OnIsMouseOverPropertyChanged = function (d, e /*AIS_TODO : DependencyPropertyChangedEventArgs*/) {
                        var sender = lang.asType(d);
                        console.assert(sender != null);
                        // Should notify when has changed...
                        if ((sender.IsMouseOverChanged != null) && (sender._throwIsMouseOverChanged)) {
                            sender.IsMouseOverChanged(sender, (function () {
                                var _tmp /*AIS_TODO = new PropertyChangedEventArgs<boolean>();
                                _tmp.OldValue = <boolean>e.OldValue;
                                _tmp.NewValue = <boolean>e.NewValue;
                                return _tmp*/;
                            })());
                        }
                        sender.ChangeVisualStateCommon(true);
                    };
                    // this value must be negative so that users can open tooltips and popup over windows
                    Window.ZIndex = -10000;
                    Window.maxWindowHistory = 5;
                    Window.DragElementName = "Drag";
                    Window.RootElementName = "Root";
                    Window.CloseElementName = "Close";
                    Window.ResizeElementName = "Resize";
                    Window.ContentElementName = "Content";
                    Window.MaximizeElementName = "Maximize";
                    Window._contexts = new System.Collections.Generic.Dictionary();
                    /// <summary>
                    /// Identifies the <see cref="Left"/> dependency property. 
                    /// </summary>
                    Window.LeftProperty = DependencyProperty.Register("Left", new System.Windows.PropertyMetadata(Window.OnLeftPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="Top"/> dependency property. 
                    /// </summary>
                    Window.TopProperty = DependencyProperty.Register("Top", new System.Windows.PropertyMetadata(Window.OnTopPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="IsActive"/> dependency property. 
                    /// </summary>
                    Window.IsActiveProperty = DependencyProperty.Register("IsActive", new System.Windows.PropertyMetadata(Window.OnIsActivePropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="IsMaximized"/> dependency property. 
                    /// </summary>
                    Window.IsMaximizedProperty = DependencyProperty.Register("IsMaximized", new System.Windows.PropertyMetadata(Window.OnIsMaximizedPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="ModalBackground"/> dependency property. 
                    /// </summary>
                    Window.ModalBackgroundProperty = DependencyProperty.Register("ModalBackground", null);
                    /// <summary>
                    /// Identifies the <see cref="IsMouseOver"/> dependency property. 
                    /// </summary>
                    Window.IsMouseOverProperty = DependencyProperty.Register("IsMouseOver", new System.Windows.PropertyMetadata(Window.OnIsMouseOverPropertyChanged));
                    /// <summary>
                    /// Identifies the <see cref="ShowCloseButton"/> dependency property. 
                    /// </summary>
                    Window.TitleProperty = DependencyProperty.Register("Title", null);
                    Window.staticConstructor = (function () {
                        Window._contexts = new System.Collections.Generic.Dictionary();
                        Window._defaultCanvas = null;
                        Window.LeftProperty = DependencyProperty.Register("Left", new System.Windows.PropertyMetadata(Window.OnLeftPropertyChanged));
                        Window.TopProperty = DependencyProperty.Register("Top", new System.Windows.PropertyMetadata(Window.OnTopPropertyChanged));
                        Window.IsActiveProperty = DependencyProperty.Register("IsActive", new System.Windows.PropertyMetadata(Window.OnIsActivePropertyChanged));
                        Window.IsMaximizedProperty = DependencyProperty.Register("IsMaximized", new System.Windows.PropertyMetadata(Window.OnIsMaximizedPropertyChanged));
                        /*AIS_TODO Window.IsResizableProperty = DependencyProperty.Register<boolean, Window>("IsResizable", new System.Windows.PropertyMetadata(<boolean>true, Window.OnIsResizablePropertyChanged));*/
                        Window.ModalBackgroundProperty = DependencyProperty.Register("ModalBackground", null);
                        /*AIS_TODO Window.ShowMaximizeButtonProperty = DependencyProperty.Register<boolean, Window>("ShowMaximizeButton", new System.Windows.PropertyMetadata(<boolean>true, Window.OnShowMaximizeButtonPropertyChanged));
                        Window.ShowCloseButtonProperty = DependencyProperty.Register<boolean, Window>("ShowCloseButton", new System.Windows.PropertyMetadata(<boolean>true, Window.OnShowCloseButtonPropertyChanged));
                        Window.DialogResultProperty = DependencyProperty.Register<MessageBoxResult, Window>("DialogResult", new System.Windows.PropertyMetadata(<MessageBoxResult>MessageBoxResult.None, Window.OnDialogResultPropertyChanged));*/
                        Window.IsMouseOverProperty = DependencyProperty.Register("IsMouseOver", new System.Windows.PropertyMetadata(Window.OnIsMouseOverPropertyChanged));
                        Window.TitleProperty = DependencyProperty.Register("Title", null);
                    })();
                    return Window;
                }(System.Windows.Controls.ContentControl));
                Controls.Window = Window;
            })(Controls = Toolkit.Controls || (Toolkit.Controls = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
/// <reference path="./Window/Window.ts" />
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Controls;
            (function (Controls) {
                var DialogBoxButtons;
                (function (DialogBoxButtons) {
                    DialogBoxButtons[DialogBoxButtons["Ok"] = 0] = "Ok";
                    DialogBoxButtons[DialogBoxButtons["YesNo"] = 1] = "YesNo";
                    DialogBoxButtons[DialogBoxButtons["YesNoCancel"] = 2] = "YesNoCancel";
                    DialogBoxButtons[DialogBoxButtons["OkCancel"] = 3] = "OkCancel";
                    DialogBoxButtons[DialogBoxButtons["AlarmCommandButton"] = 4] = "AlarmCommandButton";
                })(DialogBoxButtons = Controls.DialogBoxButtons || (Controls.DialogBoxButtons = {}));
                var MessageType;
                (function (MessageType) {
                    MessageType[MessageType["Question"] = 0] = "Question";
                    MessageType[MessageType["Information"] = 1] = "Information";
                    MessageType[MessageType["Error"] = 2] = "Error";
                    MessageType[MessageType["None"] = 3] = "None";
                    MessageType[MessageType["Warning"] = 4] = "Warning";
                    MessageType[MessageType["ViewPoint"] = 5] = "ViewPoint";
                    MessageType[MessageType["Forbidden"] = 6] = "Forbidden";
                    MessageType[MessageType["Confirm"] = 7] = "Confirm";
                    MessageType[MessageType["About"] = 8] = "About";
                    MessageType[MessageType["ae_acknowledge"] = 9] = "ae_acknowledge";
                    MessageType[MessageType["ae_enable"] = 10] = "ae_enable";
                    MessageType[MessageType["ae_disable"] = 11] = "ae_disable";
                    MessageType[MessageType["ae_unshelve"] = 12] = "ae_unshelve";
                    MessageType[MessageType["ae_suppress"] = 13] = "ae_suppress";
                    MessageType[MessageType["ae_unsuppress"] = 14] = "ae_unsuppress";
                    MessageType[MessageType["ae_clearcount"] = 15] = "ae_clearcount";
                    MessageType[MessageType["ae_reset"] = 16] = "ae_reset";
                    MessageType[MessageType["ae_shelve"] = 17] = "ae_shelve";
                    MessageType[MessageType["ae_remark"] = 18] = "ae_remark";
                })(MessageType = Controls.MessageType || (Controls.MessageType = {}));
                var DialogBox = /** @class */ (function (_super) {
                    __extends(DialogBox, _super);
                    function DialogBox() {
                        var allParams = [];
                        for (var _i = 0; _i < arguments.length; _i++) {
                            allParams[_i] = arguments[_i];
                        }
                        var _this = _super.call(this) || this;
                        _this.OnDialogBoxClosed = null;
                        _this.OnDialogBoxOpened = null;
                        var IdDialogBox;
                        if (!_this.DialogName) {
                            DialogBox.HTMLIndex += 1;
                            _this.DialogName = "DialogBoxRoot" + DialogBox.HTMLIndex;
                            IdDialogBox = DialogBox.HTMLIndex;
                        }
                        else {
                            IdDialogBox = _this.DialogName;
                        }
                        _this.CloneHTMLDialogBox(IdDialogBox);
                        switch (arguments.length) {
                            case 0:
                                _this = _super.call(this) || this;
                                _this.constructor_1();
                                break;
                            case 3:
                                _this = _super.call(this) || this;
                                _this.constructor_2(arguments[0], arguments[1], arguments[2]);
                                break;
                            case 4:
                                _this = _super.call(this) || this;
                                _this.constructor_3(arguments[0], arguments[1], arguments[2], arguments[3]);
                                break;
                            default: throw "Invalid overload call for: constructor";
                        }
                        _this.DialogBoxHTMLAngularScopeBind();
                        return _this;
                    }
                    Object.defineProperty(DialogBox.prototype, "CommandName", {
                        get: function () {
                            return this._commandName;
                        },
                        set: function (value) {
                            this._commandName = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(DialogBox.prototype, "Result", {
                        get: function () {
                            return this._result;
                        },
                        set: function (value) {
                            this._result = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(DialogBox.prototype, "IsMaximized", {
                        get: function () {
                            return this._isMaximized;
                        },
                        set: function (value) {
                            this._isMaximized = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(DialogBox.prototype, "LastLocation", {
                        get: function () {
                            return this._lastLocation;
                        },
                        set: function (value) {
                            this._lastLocation = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    Object.defineProperty(DialogBox.prototype, "Type", {
                        get: function () {
                            return this._type;
                        },
                        set: function (value) {
                            this._type = value;
                        },
                        enumerable: true,
                        configurable: true
                    });
                    DialogBox.prototype.Initialize = function (content, icon, buttons, commandName) {
                        this.OnDialogBoxClosed = new Events.Delegate();
                        this.OnDialogBoxYesButtonClicked = new Events.Delegate();
                        this.OnDialogBoxAlarmCommandClicked = new Events.Delegate();
                        //this.Closed.subscribe(this.DialogBox_Closed, this);
                        //this.Opened.subscribe(this.DialogBox_Opened, this);
                        /*AIS_TODO this.btnCancel.Click.subscribe(function (s,e) {
                           this.Result = MessageBoxResult.Cancel;
                           this.Close();
                        }, this);
                        this.btnNo.Click.subscribe(function (s,e) {
                           this.Result = MessageBoxResult.No;
                           this.Close();
                        }, this);
                        this.btnYes.Click.subscribe(function (s,e) {
                           this.Result = MessageBoxResult.Yes;
                           this.Close();
                        }, this);
                        this.btnOK.Click.subscribe(function (s,e) {
                           this.Result = MessageBoxResult.OK;
                           this.Close();
                        });*/
                        this.CommandName = commandName;
                        this.Type = icon;
                        this.DisplayButtons(buttons);
                        this.DisplayIcon(icon);
                        this.AddContent(icon, content);
                    };
                    DialogBox.prototype.DialogBox_Opened = function (sender, e) {
                        // now focus the ok button or yes button
                        /*AIS_TODO if (this.btnOK.Visibility == Visibility.Visible) {
                           this.btnOK.Focus();
                        } else if (this.btnYes.Visibility == Visibility.Visible) {
                           this.btnYes.Focus();
                        } else if (this._elementClose != null && this._elementClose.Visibility == Visibility.Visible) {
                           this._elementClose.Focus();
                        }*/
                        throw ("notImplemented");
                    };
                    DialogBox.prototype.Dispose = function () {
                        if (this._HTMLDialogBox) {
                            $("#" + this._HTMLDialogBox.attr("id")).remove();
                        }
                    };
                    DialogBox.prototype.DisplayButtons = function (buttons) {
                        this._HTMLDialogBox.find("#btnYes").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#btnNo").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#btnCancel").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#btnOK").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#btnAlarmCommand").attr('style', 'display: none');
                        switch (buttons) {
                            case DialogBoxButtons.Ok:
                                this._HTMLDialogBox.find("#btnOK").attr('style', 'display: inline-block');
                                break;
                            case DialogBoxButtons.OkCancel:
                                this._HTMLDialogBox.find("#btnCancel").attr('style', 'display: inline-block');
                                this._HTMLDialogBox.find("#btnYes").attr('style', 'display: inline-block');
                                break;
                            case DialogBoxButtons.YesNo:
                                this._HTMLDialogBox.find("#btnNo").attr('style', 'display: inline-block');
                                this._HTMLDialogBox.find("#btnYes").attr('style', 'display: inline-block');
                                break;
                            case DialogBoxButtons.YesNoCancel:
                                this._HTMLDialogBox.find("#btnCancel").attr('style', 'display: inline-block');
                                this._HTMLDialogBox.find("#btnYes").attr('style', 'display: inline-block');
                                this._HTMLDialogBox.find("#btnNo").attr('style', 'display: inline-block');
                                break;
                            case DialogBoxButtons.AlarmCommandButton:
                                this._HTMLDialogBox.find("#btnAlarmCommand").attr('style', 'display: inline-block');
                                this._HTMLDialogBox.find("#btnCancel").attr('style', 'display: inline-block');
                                break;
                        }
                    };
                    DialogBox.prototype.DisplayIcon = function (icon) {
                        this._HTMLDialogBox.find("#iconError").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#iconForbidden").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#iconWarning").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#iconInformation").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#iconQuestion").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#viewpoint").attr('style', 'display: none');
                        switch (icon) {
                            case MessageType.Error:
                                document.getElementById('iconError').setAttribute('style', 'display: inline');
                                this._HTMLDialogBox.find("#iconError").attr('style', 'display: inline');
                                this.Title = "Error";
                                this._HTMLDialogBox.find("#Title").text('Error');
                                break;
                            case MessageType.Information:
                                this._HTMLDialogBox.find("#iconInformation").attr('style', 'display: inline');
                                this.Title = "Information";
                                this._HTMLDialogBox.find("#Title").text('Information');
                                break;
                            case MessageType.Question:
                                this._HTMLDialogBox.find("#iconQuestion").attr('style', 'display: inline');
                                this.Title = "Question";
                                this._HTMLDialogBox.find("#Title").text('Question');
                                break;
                            case MessageType.Warning:
                                this._HTMLDialogBox.find("#iconWarning").attr('style', 'display: inline');
                                this.Title = "Warning";
                                this._HTMLDialogBox.find("#Title").text('Warning');
                                break;
                            case MessageType.ViewPoint:
                                this._HTMLDialogBox.find("#viewpoint").attr('style', 'display: inline');
                                this.Title = "ViewPoint";
                                this._HTMLDialogBox.find("#Title").text('ViewPoint');
                                break;
                            case MessageType.Forbidden:
                                this._HTMLDialogBox.find("#iconForbidden").attr('style', 'display: inline');
                                this.Title = "Forbidden";
                                this._HTMLDialogBox.find("#Title").text('Forbidden');
                                break;
                            case MessageType.Confirm:
                                this.Title = "Confirmation";
                                break;
                            case MessageType.None:
                                this.Title = "Empty";
                                this._HTMLDialogBox.find("#Title").text("Empty");
                                break;
                            case MessageType.About:
                                this._HTMLDialogBox.find("#viewpoint").attr('style', 'display: inline');
                                this.Title = "About FactoryTalk ViewPoint";
                                this._HTMLDialogBox.find("#Title").text('About FactoryTalk ViewPoint');
                                break;
                            case MessageType.ae_acknowledge:
                            case MessageType.ae_clearcount:
                            case MessageType.ae_disable:
                            case MessageType.ae_enable:
                            case MessageType.ae_reset:
                            case MessageType.ae_suppress:
                            case MessageType.ae_unshelve:
                            case MessageType.ae_unsuppress: {
                                this.SetAECommandCommonArea();
                                this.SetAECommandTitle(this.CommandName);
                                break;
                            }
                            case MessageType.ae_shelve: {
                                this.SetAECommandCommonArea();
                                this.SetAECommandTitle(this.CommandName);
                                this.SetAECommandShelveDurationArea();
                                break;
                            }
                            case MessageType.ae_remark: {
                                this.SetAECommandCommonArea();
                                this.SetAECommandTitle("log remark");
                                this.SetAECommandRemarkArea();
                                break;
                            }
                        }
                    };
                    DialogBox.prototype.SetAECommandCommonArea = function () {
                        this.ScaleDialogBox();
                        this._HTMLDialogBox.find("#MessageDialogBox").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#btnAlarmCommand").text(this.CommandName);
                        this._HTMLDialogBox.find("#AlarmCommandDialogBox").attr('style', 'display: inline');
                        this._HTMLDialogBox.find("#btnMaximized").attr('style', 'display: none');
                    };
                    DialogBox.prototype.SetAECommandTitle = function (titleName) {
                        this._HTMLDialogBox.find("#Title").text("Alarm&Event " + titleName);
                        this._HTMLDialogBox.find("#Title").attr('style', 'display: inline-block; overflow: hidden');
                    };
                    DialogBox.prototype.SetAECommandShelveDurationArea = function () {
                        this._HTMLDialogBox.find("#ShelveDurationLabel").attr('style', 'display: inline');
                        this._HTMLDialogBox.find("#ShelveDuration").attr('style', 'display: inline');
                        this._HTMLDialogBox.find("#ShelveDurationUnit").attr('style', 'display: inline; font-weight: normal');
                    };
                    DialogBox.prototype.SetAECommandRemarkArea = function () {
                        this._HTMLDialogBox.find("#AlarmSource").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#AlarmPath").attr('style', 'display: none');
                        this._HTMLDialogBox.find("#AlarmServer").attr('style', 'display: inline');
                        this._HTMLDialogBox.find("#AlarmServerName").attr('style', 'display: inline');
                        this._HTMLDialogBox.find("#TagName").attr('style', 'display: inline');
                        this._HTMLDialogBox.find("#TagNameValue").attr('style', 'display: inline');
                    };
                    DialogBox.prototype.ScaleDialogBox = function () {
                        if ($(window).width() > 700) {
                            this._HTMLDialogBox.find("#DivDialogBox").attr('style', 'width: 400px');
                        }
                    };
                    DialogBox.prototype.DialogBox_Closed = function (sender, e) {
                        if (this.OnDialogBoxClosed != null) {
                            /*AIS_TODO this.OnDialogBoxClosed(this.Result);*/
                        }
                        this.Closed.unsubscribe(this.DialogBox_Closed);
                    };
                    DialogBox.prototype.AddContent = function (icon, content) {
                        switch (icon) {
                            case MessageType.ae_acknowledge:
                            case MessageType.ae_clearcount:
                            case MessageType.ae_disable:
                            case MessageType.ae_enable:
                            case MessageType.ae_reset:
                            case MessageType.ae_suppress:
                            case MessageType.ae_unshelve:
                            case MessageType.ae_unsuppress: {
                                this._HTMLDialogBox.find("#AlarmPath").text(ViewPoint.Util.AlarmCommandUtils.GetAlarmSource(content));
                                this._HTMLDialogBox.find("#AlarmPath").attr('style', 'white-space: nowrap; overflow: hidden');
                                this._HTMLDialogBox.find("#AlarmCommandComments").text(ViewPoint.Util.AlarmCommandUtils.GetComments(content));
                                break;
                            }
                            case MessageType.ae_shelve: {
                                this._HTMLDialogBox.find("#AlarmPath").text(ViewPoint.Util.AlarmCommandUtils.GetAlarmSource(content));
                                this._HTMLDialogBox.find("#AlarmPath").attr('style', 'white-space: nowrap; overflow: hidden');
                                this._HTMLDialogBox.find("#ShelveDuration").attr('value', ViewPoint.Util.AlarmCommandUtils.GetShelveDuration(content));
                                this._HTMLDialogBox.find("#AlarmCommandComments").text(ViewPoint.Util.AlarmCommandUtils.GetComments(content));
                                break;
                            }
                            case MessageType.ae_remark: {
                                this._HTMLDialogBox.find("#AlarmServerName").text(ViewPoint.Util.AlarmCommandUtils.GetAlarmServerName(content));
                                this._HTMLDialogBox.find("#AlarmServerName").attr('style', 'white-space: nowrap; overflow: hidden');
                                this._HTMLDialogBox.find("#TagNameValue").text(ViewPoint.Util.AlarmCommandUtils.GetAlarmTagName(content));
                                this._HTMLDialogBox.find("#TagNameValue").attr('style', 'white-space: nowrap; overflow: hidden');
                                this._HTMLDialogBox.find("#AlarmCommandComments").text(ViewPoint.Util.AlarmCommandUtils.GetComments(content));
                                break;
                            }
                            default:
                                if (typeof (content) == "string") {
                                    var textContent = lang.asType(content);
                                    var text = new System.Windows.Controls.TextBlock();
                                    text.Foreground = new System.Windows.Media.SolidColorBrush(Colors.Black);
                                    text.Text = textContent;
                                    text.TextWrapping = TextWrapping.Wrap;
                                    text.VerticalAlignment = VerticalAlignment.Center;
                                    this.DialogContent = text;
                                }
                                else {
                                    this.DialogContent = content;
                                }
                                this.ContentToHtml($(this._HTMLDialogBox).find("#DialogContent")[0], this.DialogContent.Text);
                                break;
                        }
                    };
                    DialogBox.Show = function (content, icon, buttons) {
                        var box = new ViewPoint.Client.Toolkit.Controls.DialogBox(content, icon, buttons);
                        box.CenterOnScreen();
                        box.Show();
                        return box;
                    };
                    DialogBox.ShowModal = function (content, icon, buttons) {
                        var box = new ViewPoint.Client.Toolkit.Controls.DialogBox(content, icon, buttons);
                        box.CenterOnScreen();
                        box.ShowModal();
                        return box;
                    };
                    DialogBox.prototype.ContentToHtml = function (element, msg) {
                        while (element.firstChild)
                            element.removeChild(element.firstChild);
                        var paragraphs = msg.split("\n");
                        var releaseNotesSep = "|RN|";
                        for (var i = 0; i < paragraphs.length; i++) {
                            if (paragraphs[i].indexOf(releaseNotesSep) >= 0) {
                                var releaseNotesTitle = paragraphs[i].split(releaseNotesSep)[0];
                                var releaseNotesLink = paragraphs[i].split(releaseNotesSep)[1];
                                var releaseNotesElement = document.createElement("a");
                                releaseNotesElement.textContent = releaseNotesTitle;
                                releaseNotesElement.href = releaseNotesLink;
                                releaseNotesElement.target = "_blank";
                                element.appendChild(releaseNotesElement);
                                continue;
                            }
                            var paragraph = document.createElement("p");
                            paragraph.style.margin = "0 0 0 0px";
                            paragraph.style.whiteSpace = "pre";
                            if (paragraphs[i] == "") {
                                var newline = document.createElement("br");
                                element.appendChild(newline);
                            }
                            else {
                                paragraph.textContent = paragraphs[i];
                                element.appendChild(paragraph);
                            }
                        }
                    };
                    DialogBox.prototype.CloneHTMLDialogBox = function (name) {
                        this._HTMLDialogBox = $("#DialogBox").clone();
                        this._HTMLDialogBox.attr("id", "DialogBox" + name);
                        this._HTMLDialogBox.find("#DialogBoxRoot").attr("id", this.DialogName);
                    };
                    DialogBox.prototype.DialogBoxHTMLAngularScopeBind = function () {
                        var scope = ViewPoint.Util.CommonUtilities.ViewPointMainPageAngularScope;
                        var that = this;
                        ViewPoint.Client.Toolkit.Controls.DialogBox.CurrentDialogBox = this;
                        angular.element(document).injector().invoke(["$compile", function ($compile) {
                                var html = that._HTMLDialogBox.prop('outerHTML');
                                $("#_DialogBoxContainer").prepend($compile(html)(scope));
                            }]);
                    };
                    DialogBox.prototype.constructor_1 = function () {
                        this.Initialize(null, MessageType.None, DialogBoxButtons.Ok, null);
                    };
                    DialogBox.prototype.constructor_2 = function (content, icon, buttons) {
                        this.Initialize(content, icon, buttons, null);
                    };
                    // Support Alarm Command, Warren
                    DialogBox.prototype.constructor_3 = function (content, icon, buttons, commandName) {
                        this.Initialize(content, icon, buttons, commandName);
                    };
                    DialogBox.HTMLIndex = 0;
                    return DialogBox;
                }(ViewPoint.Client.Toolkit.Controls.Window));
                Controls.DialogBox = DialogBox;
            })(Controls = Toolkit.Controls || (Toolkit.Controls = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
var ViewPoint;
(function (ViewPoint) {
    var Client;
    (function (Client) {
        var Toolkit;
        (function (Toolkit) {
            var Utilities;
            (function (Utilities) {
                /// <summary>
                /// Represents the PathGeometryParser
                /// </summary>
                /// <remarks>
                /// Recreated from the WPF AbbreviatedGeometryParser. Great help with a Silverlight version
                /// from the StringToPathGeometry Converter on CodePlex.
                /// </remarks>
                var PathGeometryParser = /** @class */ (function () {
                    /// <summary>
                    /// Initializes a new instance of the <see cref="PathGeometryParser"/> class.
                    /// </summary>
                    function PathGeometryParser() {
                        this._formatProvider = null;
                        this._figure = null;
                        this._pathString = null;
                        this._figureStarted = null;
                        this._pathLength = 0;
                        this._curIndex = 0;
                        this._token = null;
                        this._lastStart = null;
                        this._lastPoint = null;
                        this._secondLastPoint = null;
                    }
                    /// <summary>
                    /// Parses the specified abbreviated path geometry.
                    /// </summary>
                    /// <param name="path">The path.</param>
                    /// <returns>The parsed PathGeometry</returns>
                    PathGeometryParser.prototype.ParseInternal = function (path) {
                        var pathGeometry = new System.Windows.Media.PathGeometry();
                        var first = false;
                        var lastCmd = " ";
                        this._formatProvider = CultureInfo.InvariantCulture;
                        this._pathString = path;
                        this._pathLength = path.length;
                        this._curIndex = 0;
                        this._secondLastPoint = new System.Windows.Point(0, 0);
                        this._lastPoint = new System.Windows.Point(0, 0);
                        this._lastStart = new System.Windows.Point(0, 0);
                        this._figureStarted = false;
                        while (this.ReadToken()) {
                            var cmd = this._token;
                            if (first) {
                                if (cmd != "M" && cmd != "m" && cmd != "f" && cmd != "F") {
                                    this.ThrowBadToken();
                                }
                                first = false;
                            }
                            switch (cmd) {
                                case "f":
                                case "F":
                                    var fill = this.ReadNumber(!PathGeometryParser.AllowComma);
                                    pathGeometry.FillRule = (fill == 0 ? FillRule.EvenOdd : FillRule.Nonzero);
                                    break;
                                case "m":
                                case "M":
                                    this._lastPoint = this.ReadPoint(cmd, !PathGeometryParser.AllowComma);
                                    this._figure = new System.Windows.Media.PathFigure();
                                    this._figure.StartPoint = this._lastPoint;
                                    this._figure.IsFilled = PathGeometryParser.IsFilled;
                                    this._figure.IsClosed = !PathGeometryParser.IsClosed;
                                    this._figureStarted = true;
                                    this._lastStart = this._lastPoint;
                                    lastCmd = "M";
                                    while (this.IsNumber(PathGeometryParser.AllowComma)) {
                                        this._lastPoint = this.ReadPoint(cmd, !PathGeometryParser.AllowComma);
                                        var segment = (function () {
                                            var _tmp = new System.Windows.Media.LineSegment;
                                            _tmp.Point = this._lastPoint;
                                            return _tmp;
                                        })();
                                        this._figure.Segments.Add(segment);
                                        lastCmd = "L";
                                    }
                                    break;
                                case "l":
                                case "L":
                                case "h":
                                case "H":
                                case "v":
                                case "V":
                                    this.EnsureFigure();
                                    do {
                                        switch (cmd) {
                                            case "l":
                                            case "L":
                                                this._lastPoint = this.ReadPoint(cmd, !PathGeometryParser.AllowComma);
                                                break;
                                            case "h":
                                                this._lastPoint.X += this.ReadNumber(!PathGeometryParser.AllowComma);
                                                break;
                                            case "H":
                                                this._lastPoint.X = this.ReadNumber(!PathGeometryParser.AllowComma);
                                                break;
                                            case "v":
                                                this._lastPoint.Y += this.ReadNumber(!PathGeometryParser.AllowComma);
                                                break;
                                            case "V":
                                                this._lastPoint.Y = this.ReadNumber(!PathGeometryParser.AllowComma);
                                                break;
                                        }
                                        var segment = (function () {
                                            var _tmp = new System.Windows.Media.LineSegment;
                                            _tmp.Point = this._lastPoint;
                                            return _tmp;
                                        }).apply(this);
                                        this._figure.Segments.Add(segment);
                                    } while (this.IsNumber(PathGeometryParser.AllowComma));
                                    lastCmd = "L";
                                    break;
                                case "c":
                                case "C":
                                case "s":
                                case "S":
                                    this.EnsureFigure();
                                    do {
                                        var p;
                                        if (cmd == "s" || cmd == "S") {
                                            if (lastCmd == "C") {
                                                p = this.Reflect();
                                            }
                                            else {
                                                p = this._lastPoint;
                                            }
                                            this._secondLastPoint = this.ReadPoint(cmd, !PathGeometryParser.AllowComma);
                                        }
                                        else {
                                            p = this.ReadPoint(cmd, !PathGeometryParser.AllowComma);
                                            this._secondLastPoint = this.ReadPoint(cmd, PathGeometryParser.AllowComma);
                                        }
                                        this._lastPoint = this.ReadPoint(cmd, PathGeometryParser.AllowComma);
                                        var bezier = (function () {
                                            var _tmp = new System.Windows.Media.BezierSegment;
                                            _tmp.Point1 = p;
                                            _tmp.Point2 = this._secondLastPoint;
                                            _tmp.Point3 = this._lastPoint;
                                            return _tmp;
                                        })();
                                        this._figure.Segments.Add(bezier);
                                        lastCmd = "C";
                                    } while (this.IsNumber(PathGeometryParser.AllowComma));
                                    break;
                                case "q":
                                case "Q":
                                case "t":
                                case "T":
                                    this.EnsureFigure();
                                    do {
                                        if (cmd == "t" || cmd == "T") {
                                            if (lastCmd == "Q") {
                                                this._secondLastPoint = this.Reflect();
                                            }
                                            else {
                                                this._secondLastPoint = this._lastPoint;
                                            }
                                            this._lastPoint = this.ReadPoint(cmd, !PathGeometryParser.AllowComma);
                                        }
                                        else {
                                            this._secondLastPoint = this.ReadPoint(cmd, !PathGeometryParser.AllowComma);
                                            this._lastPoint = this.ReadPoint(cmd, PathGeometryParser.AllowComma);
                                        }
                                        var quad = (function () {
                                            var _tmp = new System.Windows.Media.QuadraticBezierSegment;
                                            _tmp.Point1 = this._secondLastPoint;
                                            _tmp.Point2 = this._lastPoint;
                                            return _tmp;
                                        })();
                                        this._figure.Segments.Add(quad);
                                        lastCmd = "Q";
                                    } while (this.IsNumber(PathGeometryParser.AllowComma));
                                    break;
                                case "a":
                                case "A":
                                    this.EnsureFigure();
                                    do {
                                        var width = this.ReadNumber(!PathGeometryParser.AllowComma);
                                        var height = this.ReadNumber(PathGeometryParser.AllowComma);
                                        var rotation = this.ReadNumber(PathGeometryParser.AllowComma);
                                        var large = this.ReadBool();
                                        var sweep = this.ReadBool();
                                        this._lastPoint = this.ReadPoint(cmd, PathGeometryParser.AllowComma);
                                        var arc = (function () {
                                            var _tmp = new System.Windows.Media.ArcSegment;
                                            _tmp.Point = this._lastPoint;
                                            _tmp.Size = new System.Windows.Size(width, height);
                                            _tmp.RotationAngle = rotation;
                                            _tmp.IsLargeArc = large;
                                            _tmp.SweepDirection = (sweep ? SweepDirection.Clockwise : SweepDirection.Counterclockwise);
                                            return _tmp;
                                        })();
                                        this._figure.Segments.Add(arc);
                                    } while (this.IsNumber(PathGeometryParser.AllowComma));
                                    lastCmd = "A";
                                    break;
                                case "z":
                                case "Z":
                                    this.EnsureFigure();
                                    this._figure.IsClosed = PathGeometryParser.IsClosed;
                                    this._figureStarted = false;
                                    lastCmd = "Z";
                                    this._lastPoint = this._lastStart;
                                    pathGeometry.Figures.Add(this._figure);
                                    break;
                                default:
                                    this.ThrowBadToken();
                                    break;
                            }
                        }
                        return pathGeometry;
                    };
                    /// <summary>
                    /// Ensures the figure is started.
                    /// </summary>
                    PathGeometryParser.prototype.EnsureFigure = function () {
                        if (!this._figureStarted) {
                            this._figure = (function () {
                                var _tmp = new System.Windows.Media.PathFigure;
                                _tmp.StartPoint = this._lastPoint;
                                return _tmp;
                            })();
                            this._figureStarted = true;
                        }
                    };
                    /// <summary>
                    /// Reads the next number in the path.
                    /// </summary>
                    /// <param name="allowComma">if set to <c>true</c> [allow comma].</param>
                    /// <returns>The next number in the path.</returns>
                    PathGeometryParser.prototype.ReadNumber = function (allowComma) {
                        if (!this.IsNumber(allowComma)) {
                            this.ThrowBadToken();
                        }
                        var simple = true;
                        var start = this._curIndex;
                        if (this.More() && (this._pathString[this._curIndex] == "-" || this._pathString[this._curIndex] == "+")) {
                            this._curIndex++;
                        }
                        if (this.More() && this._pathString[this._curIndex] == "I") {
                            this._curIndex = Math.min(this._curIndex + 8, this._pathLength);
                            simple = false;
                        }
                        else if (this.More() && this._pathString[this._curIndex] == "N") {
                            this._curIndex = Math.min(this._curIndex + 3, this._pathLength);
                            simple = false;
                        }
                        else {
                            this.SkipDigits(!PathGeometryParser.AllowSign);
                            if (this.More() && this._pathString[this._curIndex] == ".") {
                                simple = false;
                                this._curIndex++;
                                this.SkipDigits(!PathGeometryParser.AllowSign);
                            }
                            if (this.More() && (this._pathString[this._curIndex] == "E" || this._pathString[this._curIndex] == "e")) {
                                simple = false;
                                this._curIndex++;
                                this.SkipDigits(PathGeometryParser.AllowSign);
                            }
                        }
                        if (simple && this._curIndex <= (start + 8)) {
                            var sign = 1;
                            if (this._pathString[start] == "+") {
                                start++;
                            }
                            else if (this._pathString[start] == "-") {
                                start++;
                                sign = -1;
                            }
                            var value = 0;
                            while (start < this._curIndex) {
                                value = value * 10 + (System.Char.Substract(this._pathString[start], "0"));
                                start++;
                            }
                            return value * sign;
                        }
                        else {
                            var s = this._pathString.substr(start, this._curIndex - start);
                            try {
                                return Convert.ToDouble(s, this._formatProvider);
                            }
                            catch (e) {
                                throw new System.FormatException(System.String.Format(CultureInfo.InvariantCulture, "Unexpected character in path '{0}' at position {1}", this._pathString, this._curIndex - 1), e);
                            }
                        }
                    };
                    /// <summary>
                    /// Reads the next point from the path.
                    /// </summary>
                    /// <param name="cmd">The command.</param>
                    /// <param name="allowComma">if set to <c>true</c> [allow comma].</param>
                    /// <returns>The next point in the path.</returns>
                    PathGeometryParser.prototype.ReadPoint = function (cmd, allowComma) {
                        var x = this.ReadNumber(allowComma);
                        var y = this.ReadNumber(PathGeometryParser.AllowComma);
                        if (cmd >= "a") {
                            x += this._lastPoint.X;
                            y += this._lastPoint.Y;
                        }
                        return new System.Windows.Point(x, y);
                    };
                    /// <summary>
                    /// Reads the next bool (0 or 1) in the path.
                    /// </summary>
                    /// <returns>The next bool in the path.</returns>
                    PathGeometryParser.prototype.ReadBool = function () {
                        this.SkipWhiteSpace(PathGeometryParser.AllowComma);
                        if (this.More()) {
                            this._token = this._pathString[this._curIndex++];
                            if (this._token == "0") {
                                return false;
                            }
                            else if (this._token == "1") {
                                return true;
                            }
                        }
                        this.ThrowBadToken();
                        return false;
                    };
                    /// <summary>
                    /// Determines whether the next token in the path is a number character.
                    /// </summary>
                    /// <param name="allowComma">if set to <c>true</c> [allow comma].</param>
                    /// <returns>
                    /// 	<c>true</c> if the next token in the path is a number character; otherwise, <c>false</c>.
                    /// </returns>
                    PathGeometryParser.prototype.IsNumber = function (allowComma) {
                        var foundComma = this.SkipWhiteSpace(allowComma);
                        if (this.More()) {
                            this._token = this._pathString[this._curIndex];
                            if ((this._token == "." || this._token == "-" || this._token == "+" || (this._token >= "0" && this._token <= "9")) || this._token == "I" || this._token == "N") {
                                return true;
                            }
                        }
                        if (foundComma) {
                            this.ThrowBadToken();
                        }
                        return false;
                    };
                    /// <summary>
                    /// Reads the next token in the path.
                    /// </summary>
                    /// <returns>The next token in the path.</returns>
                    PathGeometryParser.prototype.ReadToken = function () {
                        this.SkipWhiteSpace(!PathGeometryParser.AllowComma);
                        if (this.More()) {
                            this._token = this._pathString[this._curIndex++];
                            return true;
                        }
                        return false;
                    };
                    /// <summary>
                    /// Reflects this current point.
                    /// </summary>
                    /// <returns>The reflected point.</returns>
                    PathGeometryParser.prototype.Reflect = function () {
                        return new System.Windows.Point((2 * this._lastPoint.X) - this._secondLastPoint.X, (2 * this._lastPoint.Y) - this._secondLastPoint.Y);
                    };
                    /// <summary>
                    /// Skips the following digits in the path.
                    /// </summary>
                    /// <param name="signAllowed">if set to <c>true</c> [sign allowed].</param>
                    PathGeometryParser.prototype.SkipDigits = function (signAllowed) {
                        if (signAllowed && this.More() && (this._pathString[this._curIndex] == "-" || this._pathString[this._curIndex] == "+")) {
                            this._curIndex++;
                        }
                        while (this.More() && (this._pathString[this._curIndex] >= "0") && (this._pathString[this._curIndex] <= "9")) {
                            this._curIndex++;
                        }
                    };
                    /// <summary>
                    /// Skips the following white space in the path.
                    /// </summary>
                    /// <param name="allowComma">if set to <c>true</c> [allow comma].</param>
                    /// <returns>
                    ///     <c>true</c> if a comma was encountered; otherwise <c>false</c>.
                    /// </returns>
                    PathGeometryParser.prototype.SkipWhiteSpace = function (allowComma) {
                        var foundComma = false;
                        while (this.More()) {
                            var c = this._pathString[this._curIndex];
                            switch (c) {
                                case "\t":
                                case "\n":
                                case "\r":
                                case " ": break;
                                case ",":
                                    if (allowComma) {
                                        foundComma = true;
                                        allowComma = false;
                                    }
                                    else {
                                        this.ThrowBadToken();
                                    }
                                    break;
                                default:
                                    if ((c > " ") && (c <= "z")) {
                                        return foundComma;
                                    }
                                    if (!System.Char.IsWhiteSpace(c)) {
                                        return foundComma;
                                    }
                                    break;
                            }
                            this._curIndex++;
                        }
                        return foundComma;
                    };
                    /// <summary>
                    /// Indicates whether additional characters exist in the path.
                    /// </summary>
                    /// <returns>
                    ///     <c>true</c> if additional characters exist; otherwise <c>false</c>.
                    /// </returns>
                    PathGeometryParser.prototype.More = function () {
                        return this._curIndex < this._pathLength;
                    };
                    /// <summary>
                    /// Throws an exception representing a bad token.
                    /// </summary>
                    PathGeometryParser.prototype.ThrowBadToken = function () {
                        throw new System.FormatException(System.String.Format(CultureInfo.InvariantCulture, "Unexpected character in path '{0}' at position {1}", this._pathString, this._curIndex - 1));
                    };
                    /// <summary>
                    /// Parses the specified abbreviated path geometry.
                    /// </summary>
                    /// <param name="path">The path.</param>
                    /// <returns>The parsed PathGeometry</returns>
                    PathGeometryParser.Parse = function (path) {
                        if (path == null) {
                            throw new System.ArgumentNullException("path");
                        }
                        if (path.length == 0) {
                            throw new System.ArgumentException("Path string cannot be empty!", "path");
                        }
                        var parser = new ViewPoint.Client.Toolkit.Utilities.PathGeometryParser();
                        return parser.ParseInternal(path);
                    };
                    PathGeometryParser.AllowSign = true;
                    PathGeometryParser.AllowComma = true;
                    PathGeometryParser.IsFilled = true;
                    PathGeometryParser.IsClosed = true;
                    return PathGeometryParser;
                }());
                Utilities.PathGeometryParser = PathGeometryParser;
            })(Utilities = Toolkit.Utilities || (Toolkit.Utilities = {}));
        })(Toolkit = Client.Toolkit || (Client.Toolkit = {}));
    })(Client = ViewPoint.Client || (ViewPoint.Client = {}));
})(ViewPoint || (ViewPoint = {}));
//# sourceMappingURL=ViewPoint.Client.Toolkit.js.map